C
C  p + alpha potential for use in 6Be calculations
C   with repulsive s-wave part.
C
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	COMMON /ISOSPIN/ZN,ZC,ISO
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
	PARAMETER(RAD=2.0)
		CC = 1.44 * ZC * ZN
		if(R.gt.RAD) VCOUL = CC / R
		if(R.le.RAD) VCOUL = CC * (3.-(R/RAD)**2)/(2.*RAD)
        	if(RSCR.gt.0.01) VCOUL = VCOUL * EXP(-(R/RSCR)**2)
		V=-43.0
		if(L.eq.0) V=+20
		uc=V/(1.d0+ddexp((r-RAD)/0.7d0)) + VCOUL
		RETURN
	ENTRY ULS(L,R)
		s=ddexp((r-1.5d0)/0.35d0)
		uls=-40.d0*s/((1.d0+s)*(1.d0+s))/(0.35d0*r)
		RETURN
	ENTRY ULSC(L,R)
		ULSC = 0d0
		RETURN
	ENTRY ULL(L,R)
		ULL = 0d0
		RETURN
	ENTRY UT(L,R)
		UT = 0d0
		RETURN
	END
	FUNCTION UULS(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	UULS = ULS(L,R)
	RETURN
	END
