c	include 'he63bgau2.f'
C ****
C ****  T-basis 3-body potential  
C			ro0 = 2 fm,
C			V3 = 27.5, gs and 2+ resonance with K=20
C ****
C ****   T Faddeev:
	FUNCTION V3B(RHO,I,K,L1,L2,LTOT,STOT,JNN,II,
     x                   I1,K1,L11,L21,LTOT1,STOT1,JNN1,II1)
		IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
		B3 = -27.5
		V3B=B3 * exp(- (RHO/2.0)**3)
		if(I.ne.I1) V3B=0D0
			V3B = V3B*1.0
		RETURN
C ****   Y Faddeev:
	ENTRY U3B(RHO,I,K,L1,L2,LTOT,STOT,JNN,II,
     x                   I1,K1,L11,L21,LTOT1,STOT1,JNN1,II1)
		B3 = -27.5
		U3B=B3 * exp(- (RHO/2.0)**3)
		if(I.ne.I1) U3B=0D0
			U3B = U3B*1.0
		RETURN
	END
