C     ******************************************************************
C
C VC.......CENTRAL INTERACTION REID SOFT CORE, T=0 (NP)
C VT.......TENSOR PART
C VLS......LS PART
C
**        We use the alternate version (to have a correct deuteron)
C
C     ******************************************************************
      FUNCTION VC (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	VC = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      VC=E*(-10.463+E*(102.012+E*E*(-2915.0+7800.0*E*E)))/X
      RETURN
      END
C     ******************************************************************
      FUNCTION VT (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	VT = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      Y=1.0/X
      E=EXP(-X)
      VT=E*Y*(-10.463*(1.+3.*Y*(1.+Y)-3.*Y*(4.+Y)*E**3)+E**3*163.016)
      RETURN
      END
C     ******************************************************************
      FUNCTION VLS (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	VLS = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      VLS=251.572D0*E**4/X
      RETURN
	ENTRY VLL(L,R)
		VLL = 0d0
		RETURN
	END
