      SUBROUTINE POTDEF(L,KKKMAX,RNC,VDEF,RIN,IC1,IC2)
C        Deform the form factor UC(L,R) by deformation def.lengths DEF(k),k=2,5
C     	 Do numerical quadrature over angles
C		or UCII(L,R,IC1,IC2) if IC1*IC2>0
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 PL(0:5),C(0:5),SP(9),W(9),KTARG,VDEF(0:5)
      DATA (SP(I),I=1,5) /-.96816024,-.8360311,-.61337143,-.32425342,0./
     #     ,(W(I),I=1,5) /.08127439,.18064816,.26061070,.31234708,
     #                    .33023936 /
      COMMON /DEFORM/NTARG,KKMAX,KTARG,DEF(2:5)
        COMMON /CORES/IIC1,IIC2,CALLDEF,LPOT
	LOGICAL CALLDEF
      LOGICAL RIN,II
      SAVE PI,RSP,SP,W,C
	II = IC1*IC2>0

      IF(L.lt.0) then
C initialise
      PI = 4d0 * ATAN(1d0)
      RSP = 1.0/SQRT(PI)
      DO 2 I=1,4
      SP(5+I) =-SP(5-I)
2     W(5+I)  = W(5-I)
      DO 15 K=0,KKKMAX
15    C(K) = SQRT((2.*K+1.)/4.)
	return
      endif

      DO 18 K=0,KKKMAX
18    VDEF(K) = 0.
         PL(0) = 1.
      DO 50 NU=1,9
         U = SP(NU)
         PL(1) = U
         DO 20 K=2,KKKMAX
20       PL(K) = ((2*K-1)*U*PL(K-1) - (K-1)*PL(K-2))/DBLE(K)
      SH  = 0.0
      DO 25 K=2,KKKMAX
25       SH = SH + C(K)*RSP * PL(K) * DEF(K)
         R = RNC - SH
	 DO 40 K=0,KKKMAX
	    IF(K.ge.2) then
	    	IF(DEF(K).eq.0d0) go to 40
	    endif
            CNS = W(NU) * PL(K) * C(K)
          if(RIN.and..not.II) VDEF(K)=VDEF(K) + CNS * UC(L,R)
          if(RIN.and.     II) VDEF(K)=VDEF(K) + CNS * UCII(L,R,IC1,IC2)
          if(.not.RIN) VDEF(K)=VDEF(K) + CNS * UUC(L,R)
40      CONTINUE
50      CONTINUE
!	if(LPOT>=10) VDEF(0) = UC(L,R)  !  keep original monopoles
	RETURN
      END
