	DOUBLE PRECISION FUNCTION POJAC(N,AL,BE,X)
C CALCULATES THE JACOBI POLINOMIALS
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	A=1.
	IF(N.EQ.0) THEN
	POJAC=A
	RETURN
	END IF
	B=.5d0*((AL-BE)+(AL+BE+2.d0)*X)
	IF(N.EQ.1) THEN
	POJAC=B
	RETURN
	END IF
	DO 1 I=2,N
	P1=2.d0*I+AL+BE-2.d0
	P2=P1+1.d0
	P3=P2+1.d0
	D=2.d0*I*(AL+BE+I)*P1
	C=(P2*(P1*P3*X+AL*AL-BE*BE)*B-2.d0*(I+AL-1.d0)*(I+BE-1.d0)*
     X			P3*A)/D
	A=B  	
1	B=C
	POJAC=C
	RETURN
	END
	SUBROUTINE HHBAS(PJ,XJ,NJAC,L1MAX,L2MAX,LDMIN,LDMAX,NN,
     x		NM,MNM,MAXL,MLT,MJAC)
	implicit double precision(a-h,o-z)
	dimension XJ(NJAC),PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC),
     x		H1(0:L1MAX),H2(0:L2MAX)
	double precision jacnorm

	DO 1 I=1,NJAC
	XX=XJ(I)
	Z1=DSQRT(1.-XX)
	Z2=DSQRT(1.+XX)
	H1(0)=1.
	H2(0)=1.
	DO 80 J=1,L1MAX
80	H1(J)=H1(J-1)*Z1
	DO 81 J=1,L2MAX
81	H2(J)=H2(J-1)*Z2
	DO 2 L1=0,L1MAX
	AL=L1+.5D0
	DO 32 LD=LDMIN,LDMAX
	L2=L1+NN-2*LD
	IF(L2.lt.0.or.L2.gt.L2MAX) GO TO 33
	BE=L2+0.5D0
	DO 3 N=0,NM
3	PJ(N,L1,LD,I)=H1(L1)*H2(L2)*JACNORM(N,L1,L2)*POJAC(N,AL,BE,XX)
! 	write(10,50) L1,LD,I,PJ(0:min(NM,9),L1,LD,I)
!50 	format(' PJ(*,',3i3,')=',10f10.6)
33	CONTINUE
32	CONTINUE
2 	CONTINUE
1	CONTINUE
	return
	end
