      SUBROUTINE PRINTCO(NMAX,mxfile,RR,XL,NLAG,XLAG,PRIPOT,IMAX,IMAXH,
     x                    WW,WN1,MCH,NOW,EQN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  WN1(MCH,MCH),WW(MCH,MCH,NLAG),XL(NLAG),XLAG(0:NLAG)
      real*8 wn11(IMAX,IMAX)
      LOGICAL PRIPOT
      CHARACTER EQN

      if(PRIPOT) then
C
C----  PRINT SOME OF THE COUPLING TERMS WW 
c
	if(NMAX.ne.0) then
	  do i=6,mxfile,4
	  write(i,*)
	  write(i,*) 'All Gauss-laguerre points:'
	  write(i,755) (RR*XL(j),j=1,NLAG)
	  write(i,*)
	  write(i,*) 'Gauss-laguerre points for NMAX =',abs(NMAX),':'
	  write(i,755) (RR*XLAG(j),j=1,abs(NMAX))
	  enddo
	else
	  do i=6,mxfile,4
	  write(i,*)
	  write(i,*) 'All radial points:'
	  write(i,755) (RR*XL(j),j=1,NLAG)
	  enddo
	  endif

	  if(EQN.ne.'T'.or.NOW.ge.2) then
	  write(88,189) 
189	  format('# All radial couplings:')
	  do 200 I=1,IMAXH
	  do 200 J=1,IMAXH
	  write(88,190) I,J
190	  format('# Coupling between channels ',2i4)
	  do 195 K=1,NLAG
195	  write(88,196) RR*XL(K),WW(I,J,K)
	  write(88,*)'&'
196	  format(f9.3,g14.4)
200	  continue
	  endif

c	NINC = max(NLAG/8,1)
	NINC = max(NLAG/5,1)
c	NINC = 1
	write(10,*) 
	write(10,*) 'Diagonal couplings:'
	write(10,755) (RR*XL(I),I=1,NLAG,NINC)
	do 658 k=1,IMAXH
658	write(10,760) K,K,(WW(K,K,I),I=1,NLAG,NINC)
	write(10,*) 
	write(10,*) 'Selected couplings:'
	write(10,755) (RR*XL(I),I=1,NLAG,NINC)
C755	format(' Radii:   ',8f8.3,:,/(10x,8f8.3))
c755	format(' Radii:   ',7f10.3,:,/(10x,7f10.3))
755	format(' Radii:   ',9f12.3,:,/(10x,9f12.3))
	do 758 j=1,IMAXH
	do 758 k=1,IMAXH
758	write(10,760) J,K,(sm(WW(J,K,I)),I=1,NLAG,NINC)
c760	format(1x,I3,'<-',I3,':',8f8.3,:,/(10x,8f8.3))
c760	format(1x,I3,'<-',I3,':',7g10.2,:,/(10x,7g10.2))
760	format(1x,I4,'<-',I4,':',9g12.4,:,/(10x,9g12.4))
*	return
	k=2
	write(10,7611) RR*XL(k)
 7611   format(/'  Coupling matrix at R =',F8.3,':'/)
  	do 7631 I=1,IMAXH
 7631	write(10,7651) I,(WW(I,I1,k),I1=1,IMAXH)
c7651	format(1x,i3,10f8.3,:,/(4x,10f8.3))
 7651	format(1x,i3,16f8.3,:,/(4x,16f8.3))
	write(10,770) 
 770    format(/'  Normalisation & permutation matrix:'/)
  	do 780 I=1,IMAX
 780	write(10,790) I,(WN1(I,I1),I1=1,IMAX)
c790	format(1x,i3,10f8.4,:,/(4x,10f8.4))
 790	format(1x,i3,16f8.4,:,/(4x,16f8.4))
	if(NOW==0) then
	  WN11(:,:) = WN1(1:IMAX,1:IMAX)
      	  call HDIAG(WN11,IMAX,IMAX,1,U,NR)
	  write(10,800) 
 800      format(/'  Normalisation eigenvalues:'/)
 	  write(10,790) IMAX,(WN11(I1,I1),I1=1,IMAX)
	  endif
	endif
	return
	end
	function sm(x)
      	implicit double precision (a-h,o-z)
	sm = x
	if(abs(x)<1d-15) sm = 0d0
	return
	end

      SUBROUTINE VDIAG(RR,WW,MCH,XL,NLAG,NC,
     X			KVAL,KKN,EQN,H2M,FESH,IFO,II2,ICN,ETARG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  WW(MCH,MCH,NLAG),XL(NLAG),KVAL(NC),KKN(NC),
     X		IFO(MCH,3),II2(MCH),ICN(MCH),ETARG(10)
      DIMENSION VECSR(NC,NC),VECSI(NC,NC),VALR(NC),NITER(NC),VALI(NC),
     X		WWL(NC,NC)
      LOGICAL FESH
      CHARACTER EQN
      RL(X,XLIM) = max(-XLIM,min(XLIM,x))

*     print *,'VDIAG: RR,MCH,NLAG,NC=',real(RR),MCH,NLAG,NC
C
C----  DIAGONALISE THE COUPLING TERMS WW 
c
	do 100 k=1,NLAG
	R =  RR*XL(k)
	write(10,1) R
 1        format('  Diagonalised coupling matrix at R =',F8.3)
	 IFAIL = 0
	do 6 I=1,NC
	 ICI = I
	 if(FESH) ICI = IFO(I,1)
	 KK = KVAL(ICI)
	 if(EQN.eq.'N') KK=KKN(ICI)
	 IC=II2(ICI)
	 if(EQN.eq.'N') IC=ICN(ICI)
	do 5 J=1,NC
5	WWL(I,J) = WW(I,J,k)
6	WWL(I,I) = WWL(I,I) + ETARG(IC) + H2M*(KK+1.5)*(KK+2.5)/(R*R)
!   	   write(6,*) 'WW interaction matrix @ ',R
!   	   call wrtmat(WWL,NC,NC,NC,6)
!	   call flush(6)
!	write(90,10) R,(WWL(I,I),I=1,min(NC,16))
!	write(90,10) R,(WWL(I,I)*R*R,I=1,min(NC,16))
	write(90,11) R,(WWL(I,I),I=1,min(NC,16))
c	call tnormal(WWL,MCH,NC,err)
c	write(93,*) r,err
	  call f02agf(WWL,NC,NC,valr,vali,vecsr,NC,vecsi,NC,NITER,
     x			IFAIL)
c	sort ascending:
	  IFAIL=0
	  call m01daf(VALR,1,NC,'a',NITER,IFAIL)
	  call m01zaf(NITER,1,NC,IFAIL)
!	  write(91,10) R,(VALR(NITER(I))*R*R,I=1,min(NC,16))
	  write(91,11) R,(RL(VALR(NITER(I))*R*R,1000d0),I=1,min(NC,16))
c	  write(92,10) R,(VALI(NITER(I))*R*R,I=1,min(NC,16))
!	  write(92,10) R,(VALR(NITER(I))    ,I=1,min(NC,16))
!	  write(92,11) R,(RL(VALR(NITER(I)),50d0)   ,I=1,min(NC,16))
	  write(92,10) R,(VALR(NITER(I))   ,I=1,min(NC,6))
10	format(f8.3,1p,20e10.2)
11	format(f8.3,20f10.3)
100	continue
	do 110 i=90,92
	write(i,*) '&'
110	call flush(i)
	return
	end
      subroutine tnormal (v,nmax,n,err)
	implicit real*8(a-h,o-z)
	dimension v(nmax,nmax)

c	determine if V V^T = V^T V, 
c	   ie if V can be diagonalised by a unitary transformation.
	err = 0d0
	do 10 i=1,n
	do 10 j=1,n
	  sum = 0d0
	  do 5 k=1,n
5	  sum = sum + v(i,k)*v(j,k) - v(k,i)*v(k,j)
	err = max(err,abs(sum))
10	continue
	return
	end
      SUBROUTINE M01DAF(RV,M1,M2,ORDER,IRANK,IFAIL)
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     M01DAF RANKS A VECTOR OF REAL NUMBERS IN ASCENDING
C     OR DESCENDING ORDER.
C
C     M01DAF USES A VARIANT OF LIST-MERGING, AS DESCRIBED
C     BY KNUTH. THE ROUTINE TAKES ADVANTAGE OF NATURAL
C     ORDERING IN THE DATA, AND USES A SIMPLE LIST INSERTION
C     IN A PREPARATORY PASS TO GENERATE ORDERED LISTS OF
C     LENGTH AT LEAST 10. THE RANKING IS STABLE: EQUAL ELEMENTS
C     PRESERVE THEIR ORDERING IN THE INPUT DATA.
C
C     THE MINIMUM LENGTH OF THE LISTS AT THE END OF THE
C     PREPARATORY PASS IS DEFINED BY THE VARIABLE MAXINS.
C
C     WRITTEN BY N.M.MACLAREN, UNIVERSITY OF CAMBRIDGE.
C     REVISED BY NAG CENTRAL OFFICE.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='M01DAF')
      INTEGER           MAXINS
      PARAMETER         (MAXINS=10)
C     .. Scalar Arguments ..
      INTEGER           IFAIL, M1, M2
      CHARACTER*1       ORDER
C     .. Array Arguments ..
      DOUBLE PRECISION  RV(M2)
      INTEGER           IRANK(M2)
C     .. Local Scalars ..
      DOUBLE PRECISION  A, B, C
      INTEGER           I, I1, I2, IERR, ILIST, J, J1, J2, K, K1, K2, L,
     *                  LIST1, LIST2, NLAST, NPREV, NREC
C     .. Local Arrays ..
      CHARACTER*80      P01REC(2)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. Executable Statements ..
C
C       CHECK THE ARGUMENTS AND DEAL WITH THE TRIVIAL CASE.
C
      IF (M2.LT.1 .OR. M1.LT.1 .OR. M1.GT.M2) THEN
         IERR = 1
         WRITE (P01REC,FMT=99999) M1, M2
         NREC = 2
      ELSE IF (ORDER.NE.'A' .AND. ORDER.NE.'a' .AND. ORDER.NE.'D' .AND.
     *         ORDER.NE.'d') THEN
         IERR = 2
         WRITE (P01REC,FMT=99998) ORDER
         NREC = 1
      ELSE IF (M1.EQ.M2) THEN
         IRANK(M2) = M2
         IERR = 0
      ELSE
         IERR = 0
C
C        INITIALISE, USING NATURAL RUNS IN BOTH DIRECTIONS AND
C        STRAIGHT LIST INSERTION FOR SMALL LISTS.
C
C        I  POINTS TO THE SMALLEST ELEMENT IN THE CURRENT LIST
C        J  POINTS TO THE LARGEST  ELEMENT IN THE CURRENT LIST
C        B  IS THE VALUE OF THE SMALLEST ELEMENT IN CURRENT LIST
C        C  IS THE VALUE OF THE LARGEST  ELEMENT IN CURRENT LIST
C
         ILIST = -1
         K = M1
         I = K
         J = K
         L = K + MAXINS
         B = RV(K)
         C = B
         DO 40 K = M1 + 1, M2
C
C           DEAL WITH ADDITIONS AT EITHER END.
C
            A = RV(K)
            IF (A.GE.C) THEN
               IRANK(J) = K
               J = K
               C = A
            ELSE IF (A.LT.B) THEN
               IRANK(K) = I
               I = K
               B = A
            ELSE
C
C              DO AN ASCENDING LIST INSERTION.
C
               IF (K.LT.L) THEN
                  I2 = I
   20             I1 = I2
                  I2 = IRANK(I1)
                  IF (A.GE.RV(I2)) GO TO 20
                  IRANK(I1) = K
                  IRANK(K) = I2
               ELSE
C
C                 ADD THE CURRENT LIST ON TO THE OTHERS.
C
                  IF (ILIST.LT.0) THEN
                     LIST1 = -I
                     ILIST = 0
                  ELSE IF (ILIST.EQ.0) THEN
                     LIST2 = -I
                     ILIST = 1
                     NPREV = NLAST
                  ELSE
                     IRANK(NPREV) = -I
                     NPREV = NLAST
                  END IF
C
                  NLAST = J
                  I = K
                  J = K
                  L = K + MAXINS
                  B = RV(K)
                  C = B
               END IF
            END IF
   40    CONTINUE
C
C        TIDY UP AT THE END.
C
         IRANK(J) = 0
         IF (ILIST.LT.0) THEN
            LIST1 = -I
            GO TO 280
         ELSE IF (ILIST.EQ.0) THEN
            LIST2 = -I
         ELSE
            IRANK(NPREV) = -I
         END IF
         IRANK(NLAST) = 0
C
C        AT THIS POINT:
C        LIST1 = - (INDEX OF LEAST ELEMENT IN THE FIRST LIST)
C        LIST2 = - (INDEX OF LEAST ELEMENT IN THE SECOND LIST)
C        FOR EACH K, IRANK(K) IS THE INDEX OF THE NEXT ELEMENT IN THE
C        CURRENT LIST, EXCEPT THAT, IF THERE IS NO SUCH ELEMENT,
C        IRANK(K) IS - (INDEX OF THE LEAST ELEMENT IN THE NEXT LIST
C        BUT 1)  OR 0 IF THERE IS NO SUCH LIST.
C
C        START MERGING LISTS BY PAIRS.
C
   60    ILIST = -1
         I = -LIST1
         J = -LIST2
   80    K = I
         IF (RV(I).GT.RV(J)) K = J
         IF (ILIST.LT.0) THEN
            LIST1 = -K
            ILIST = 0
         ELSE IF (ILIST.EQ.0) THEN
            LIST2 = -K
            ILIST = 1
            NLAST = L
         ELSE
            IRANK(NLAST) = -K
            NLAST = L
         END IF
C
C        MOVE ALONG THE LISTS UNTIL ONE FINISHES.
C
C        NEW VARIABLES I2, J2 AND K2 ARE USED INSTEAD OF I, J AND K
C        WITHIN THE INNERMOST BLOCK TO ENCOURAGE OPTIMISING COMPILERS TO
C        STORE THEM IN REGISTERS.
C         I2 POINTS TO THE CURRENT ELEMENT IN THE FIRST LIST
C         J2 POINTS TO THE CURRENT ELEMENT IN THE SECOND LIST
C         K2 POINTS TO THE CURRENT ELEMENT IN THE MERGED LIST
C
         I2 = I
         J2 = J
         IF (K.NE.I2) GO TO 140
  100    A = RV(J2)
         K2 = I2
  120    I2 = K2
         K2 = IRANK(I2)
         IF (K2.LE.0) GO TO 180
         IF (A.GE.RV(K2)) GO TO 120
         IRANK(I2) = J2
         I2 = K2
  140    A = RV(I2)
         K2 = J2
  160    J2 = K2
         K2 = IRANK(J2)
         IF (K2.LE.0) GO TO 200
         IF (A.GT.RV(K2)) GO TO 160
         IRANK(J2) = I2
         J2 = K2
         GO TO 100
C
C        ADD THE REMAINS OF ONE LIST TO THE OTHER.
C
  180    K = 1
         I1 = K2
         GO TO 220
  200    K = 2
         J1 = K2
  220    I = I2
         J = J2
         IF (K.EQ.1) THEN
C
C           FIRST LIST IS EXHAUSTED
C
            IRANK(I) = J
            I = -I1
            J1 = J
  240       J = J1
            J1 = IRANK(J)
            IF (J1.GT.0) GO TO 240
            L = J
            J = -J1
         ELSE
C
C           SECOND LIST IS EXHAUSTED
C
            IRANK(J) = I
            J = -J1
            I1 = I
  260       I = I1
            I1 = IRANK(I)
            IF (I1.GT.0) GO TO 260
            L = I
            I = -I1
         END IF
C
C        TIDY UP AND CARRY ON IF NOT FINISHED.
C
         IF ((I.NE.0) .AND. (J.NE.0)) GO TO 80
         IRANK(L) = 0
         K = I + J
         IF (ILIST.GT.0) THEN
            IRANK(NLAST) = -K
            GO TO 60
         ELSE IF (K.NE.0) THEN
            LIST2 = -K
            GO TO 60
         END IF
C
C        IF DESCENDING, REVERSE ALL POINTERS BETWEEN EQUALITY
C        BLOCKS.
C
  280    IF ((ORDER.EQ.'D') .OR. (ORDER.EQ.'d')) THEN
            I = 0
            J = -LIST1
  300       K = J
            K1 = K
            A = RV(K)
  320       K = K1
            K1 = IRANK(K)
            IF (K1.NE.0) THEN
               IF (A.EQ.RV(K1)) GO TO 320
            END IF
            IRANK(K) = I
            I = J
            J = K1
            IF (J.NE.0) GO TO 300
            LIST1 = -I
         END IF
C
C        CONVERT THE LIST FORM TO RANKS AND RETURN.
C
         K = M1
         I = -LIST1
  340    I1 = IRANK(I)
         IRANK(I) = K
         K = K + 1
         I = I1
         IF (I.GT.0) GO TO 340
C
      END IF
C
      IF (IERR.NE.0) THEN
         IFAIL = P01ABF(IFAIL,IERR,SRNAME,NREC,P01REC)
      ELSE
         IFAIL = 0
      END IF
      RETURN
C
99999 FORMAT (' ** On entry, one or more of the following parameter va',
     *  'lues is illegal',/'    M1 =',I16,'  M2 =',I16)
99998 FORMAT (' ** On entry, ORDER has an illegal value: ORDER = ',A1)
      END
      SUBROUTINE M01ZAF(IPERM,M1,M2,IFAIL)
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     M01ZAF INVERTS A PERMUTATION, AND HENCE CONVERTS A RANK VECTOR TO
C     AN INDEX VECTOR, OR VICE VERSA.
C
C     WRITTEN BY N.M.MACLAREN, UNIVERSITY OF CAMBRIDGE.
C     REVISED BY NAG CENTRAL OFFICE.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='M01ZAF')
C     .. Scalar Arguments ..
      INTEGER           IFAIL, M1, M2
C     .. Array Arguments ..
      INTEGER           IPERM(M2)
C     .. Local Scalars ..
      INTEGER           I, IERR, J, K, L
C     .. Local Arrays ..
      CHARACTER*80      P01REC(2)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. Executable Statements ..
C
C       CHECK THE PARAMETERS AND MODIFY IPERM.
C
      IF (M2.LT.1 .OR. M1.LT.1 .OR. M1.GT.M2) THEN
         IERR = 1
         WRITE (P01REC,FMT=99999) M1, M2
      ELSE
         IERR = 0
         DO 20 I = M1, M2
            J = IPERM(I)
            IF ((J.LT.M1) .OR. (J.GT.M2)) GO TO 100
            IF (I.NE.J) IPERM(I) = -J
   20    CONTINUE
C
C        REVERSE EACH NON-TRIVIAL CYCLE.
C
         DO 60 I = M1, M2
            K = -IPERM(I)
            IF (K.GE.0) THEN
               J = I
   40          L = -IPERM(K)
               IF (L.GT.0) THEN
                  IPERM(K) = J
                  J = K
                  K = L
                  GO TO 40
               END IF
               IF (IPERM(I).LT.0) GO TO 120
            END IF
   60    CONTINUE
      END IF
C
C       RETURN
C
   80 IF (IERR.NE.0) THEN
         IFAIL = P01ABF(IFAIL,IERR,SRNAME,2,P01REC)
      ELSE
         IFAIL = 0
      END IF
      RETURN
  100 IERR = 2
      WRITE (P01REC(2),FMT=99997) I, J
      GO TO 140
  120 IERR = 3
      WRITE (P01REC(2),FMT=99996) K
  140 WRITE (P01REC(1),FMT=99998)
      GO TO 80
C
99999 FORMAT (' ** On entry, one or more of the following parameter va',
     *  'lues is illegal',/'    M1 =',I16,'  M2 =',I16)
99998 FORMAT (' ** IPERM(M1:M2) does not contain a permutation of the ',
     *  'integers M1 to M2')
99997 FORMAT ('    IPERM(',I6,') contains an out-of-range value',I16)
99996 FORMAT ('    IPERM contains a repeated value',I16)
      END
      SUBROUTINE HDIAG(H,N,NSMAX,IEGEN,U,NR)
C     MIHDI3,FORTRAN 22 DIAGONALIZATION OF A REAL SYMMETRIC MATRIX BY
C        THE JACOBI METHOD.
C     MAY 19, 1959
C     CALLING SEQUENCE FOR DIAGONALIZATION
C            CALL  HDIAG(H, N, IEGEN, U, NR)
C     IEGEN MUST BE SET UNEQUAL TO ZERO IF ONLY EIGENVALUES ARE
C             TO BE COMPUTED.
C
C     N IS THE ORDER OF THE MATRIX.  H.
C            WHERE H IS THE ARRAY TO BE DIAGONALIZED.
C     IEGEN MUST BE SET EQUAL TO ZERO IF EIGENVALUES AND EIGENVECTORS
C           ARE TO BE COMPUTED.
C
C     U IS THE UNITARY MATRIX USED FOR FORMATION OF THE EIGENVECTORS.
C
C     NR IS THE NUMBER OF ROTATIONS.
C
C     A DIMENSION STATEMENT MUST BE INSERTED IN THE SUBROUTINE.
C     DIMENSION H(N,N), U(N,N), X(N), IQ(N)
C
C
C     THE SUBROUTINE OPERATES ONLY ON THE ELEMENTS OF H THAT ARE TO THE
C             RIGHT OF THE MAIN DIAGONAL. THUS, ONLY A TRIANGULAR
C             SECTION NEED BE STORED IN THE ARRAY H.
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION H(NSMAX,NSMAX), U(NSMAX,NSMAX), X(NSMAX), IQ(NSMAX)
      ONE = 1d0
      TWO = 2d0
      IF(IEGEN) 15,10,15
   10 DO 14 I = 1,N
      DO 14 J = 1,N
      IF(I - J) 12,11,12
   11 U(I,J) = 1.0
      GO TO 14
   12 U(I,J) = 0.
   14 CONTINUE
C
   15 NR=0
      IF(N - 1) 1000,1000,17
C
C     SCAN FOR LARGEST OFF DIAGONAL ELEMENT IN EACH ROW
C     X(I) CONTAINS LARGEST ELEMENT IN ITH ROW
C     IQ(I) HOLDS SECOND SUBSCRIPT DEFINING POSITION OF ELEMENT
C
   17 NMI1 = N - 1
      DO 30 I = 1,NMI1
      X(I) = 0.
      IPL1 = I + 1
      DO 30 J = IPL1,N
      IF(X(I) - ABS (H(J,I))) 20,20,30
   20 X(I) = ABS (H(J,I))
      IQ(I) = J
   30 CONTINUE
C
C     SET INDICATOR FOR SHUT-OFF.RAP=2**-27,NR = NO. OF ROTATIONS
      RAP=7.450580596d-9
      HDTEST=1.0d100
C
C     FIND MAXIMUM OF X(I) S FOR PIVOT ELEMENT AND
C     TEST FOR END OF PROBLEM
C
   40 DO 70 I = 1,NMI1
      IF(I - 1) 60,60,45
   45 IF(XMAX-X(I)) 60,70,70
   60 XMAX = X(I)
      JPIV = IQ(I)
      IPIV = I
   70 CONTINUE
C
C     IS MAX. X(I) EQUAL TO ZERO, IF LESS THAN HDTEST, REVISE HDTEST
      IF(XMAX) 1000,1000,80
   80 IF (HDTEST) 90,90,85
   85 IF(XMAX - HDTEST) 90,90,148
   90 HDIMIN = ABS (H(1,1))
      DO 110 I = 2,N
      IF(HDIMIN - ABS (H(I,I))) 110,110,100
  100 HDIMIN = ABS (H(I,I))
  110 CONTINUE
C
      HDTEST = HDIMIN*RAP
C
C     RETURN IF MAX.H(J,I)LESS THAN(2**-27)ABSF(H(K,K)-MIN)
      IF (HDTEST - XMAX) 148,1000,1000
  148 NR = NR + 1
C
C     COMPUTE TANGENT, SINE AND COSINE, H(I,I),H(J,J)
  150 TANG = SIGN (TWO,(H(IPIV,IPIV)-H(JPIV,JPIV)))*H(JPIV,IPIV)/(ABS (H
     1(IPIV,IPIV)-H(JPIV,JPIV))+SQRT ((H(IPIV,IPIV)-H(JPIV,JPIV))**2+4.0
     2*H(JPIV,IPIV)**2))
      COSINE = 1.0/SQRT (1.0+TANG**2)
      SINE = TANG*COSINE
      HII = H(IPIV,IPIV)
      H(IPIV,IPIV) = COSINE**2*(HII+TANG*(2.*H(JPIV,IPIV)+TANG*H(JPIV,JP
     1IV)))
      H(JPIV,JPIV)=COSINE**2*(H(JPIV,JPIV)-TANG*(2.*H(JPIV,IPIV)-TANG*H
     1II))
      H(JPIV,IPIV)= 0.
C
C     PSEUDO RANK THE EIGENVALUES
C     ADJUST SINE AND COS FOR COMPUTATION OF H(IK) AND U(IK)
      IF(H(IPIV,IPIV) -H(JPIV,JPIV)) 152,153,153
  152 HTEMP = H(IPIV,IPIV)
      H(IPIV,IPIV) = H(JPIV,JPIV)
      H(JPIV,JPIV) = HTEMP
      HTEMP = SIGN (ONE, -SINE)*COSINE
      COSINE = ABS (SINE)
      SINE = HTEMP
  153 CONTINUE
C
C     INSPECT THE IQS BETWEEN I + 1 AND N-1 TO DETERMINE
C     WHETHER A NEW MAXIMUM VALUE SHOULD BE COMPUTED SINCE
C     THE PRESENT MAXIMUM IS IN THE I OR J ROW.
C
      DO 350 I = 1,NMI1
      IF(I-IPIV) 210,350,200
  200 IF(I-JPIV) 210,350,210
  210 IF(IQ(I)-IPIV) 230,240,230
  230 IF(IQ(I)-JPIV)350,240,350
  240 K = IQ(I)
  250 HTEMP=H(K,I)
      H(K,I) = 0.
      IPL1 = I + 1
      X(I) = 0.
C
C     SEARCH IN DEPLETED ROW FOR NEW MAXIMUM
C
      DO 320 J = IPL1,N
      IF(X(I)-ABS (H(J,I))) 300,300,320
  300 X(I) = ABS (H(J,I))
      IQ(I) = J
  320 CONTINUE
      H(K,I) = HTEMP
  350 CONTINUE
C
      X(IPIV) = 0.
      X(JPIV) = 0.
C
C     CHANGE THE OTHER ELEMENTS OF H
C
      DO 530 I = 1,N
C
      IF(I-IPIV) 370,530,420
  370 HTEMP = H(IPIV,I)
      H(IPIV,I) = COSINE*HTEMP + SINE * H(JPIV,I)
      IF(X(I) - ABS (H(IPIV,I)))380,390,390
  380 X(I) = ABS (H(IPIV,I))
      IQ(I) = IPIV
  390 H(JPIV,I) = -SINE*HTEMP + COSINE*H(JPIV,I)
      IF(X(I) - ABS (H(JPIV,I))) 400,530,530
  400 X(I) = ABS (H(JPIV,I))
      IQ(I) = JPIV
      GO TO 530
C
  420 IF(I-JPIV) 430,530,480
  430 HTEMP = H(I,IPIV)
      H(I,IPIV) = COSINE*HTEMP + SINE*H(JPIV,I)
      IF(X(IPIV) - ABS (H(I,IPIV)) ) 440,450,450
  440 X(IPIV) = ABS (H(I,IPIV))
      IQ(IPIV) = I
  450 H(JPIV,I) = -SINE*HTEMP + COSINE*H(JPIV,I)
      IF(X(I) - ABS ( H(JPIV,I)) ) 400,530,530
C
  480 HTEMP = H(I,IPIV)
      H(I,IPIV) = COSINE*HTEMP + SINE*H(I,JPIV)
      IF(X(IPIV) - ABS ( H(I,IPIV)) ) 490,500,500
  490 X(IPIV) = ABS (H(I,IPIV))
      IQ(IPIV) = I
  500 H(I,JPIV) = -SINE*HTEMP + COSINE*H(I,JPIV)
      IF(X(JPIV) - ABS ( H(I,JPIV))) 510,530,530
  510 X(JPIV) = ABS (H(I,JPIV))
      IQ(JPIV) = I
  530 CONTINUE
C
C     TEST FOR COMPUTATION OF EIGENVECTORS
C
      IF(IEGEN) 40,540,40
  540 DO 550 I = 1,N
      HTEMP = U(IPIV,I)
      U(IPIV,I) = COSINE*HTEMP + SINE*U(JPIV,I)
  550 U(JPIV,I) = -SINE*HTEMP + COSINE*U(JPIV,I)
      GO TO 40
 1000 RETURN
      END
