	SUBROUTINE QUAJAC1(X,W,N)
C GAUSS-JACOBI QUADRATURE FORMULAS
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION X(N),W(N)
	PI=3.1415926535897932384626433832795
	DO 1 I=1,N
	A=PI/(N+1.d0)
	B=A*I
	C=DCOS(B)
	X(I)=C
	S=1.D0-C*C
1	W(I)=A*S
	RETURN
	END
	
