c
C  coupling order |[(S1,S2)S, (LX,LY)LL, Jnn], JC; JTOT>
C
c 	where S1=S2=1/2 and JC = core spin (zero for 6Li and 6He).
c
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (MRXY=201, MRXY2=MRXY**2,MAXV=1000)
      REAL*8 V(MRXY,MRXY),RV(MRXY),JC,JTOT,S
      PARAMETER(KO=6, IPC=3, NFL=5) 
      character psign(3)
      data psign/'-','?','+'/

       Z = 0.0
       FPI = 4d0*atan(1d0)*4d0
C
      REWIND NFL
      READ(NFL,*,end=300) NRXY,RSTEP,II,EEIG
	if(NRXY.gt.MRXY) stop 'MRXY'
	WN = 0.0
	VN = 0.0
      DO 200 IVERT=0,2
      READ(NFL,*,end=300) 
      READ(NFL,*) 

	write(6,2) EEIG,IVERT
2	format(/' EIGENSTATE at E =',f8.3,', IVERT =',I2,':'/)
      	XNT = 0.
      DO 110 IA=1,100
      READ(NFL,915) LX,LY,LL,S,JNN,IC,JC,JTOT
	if(LX.lt.0) go to 120
915	format(3x,6i3,2f4.1)
      IPAR = (-1)**(LX+LY)
      if(IA.eq.1) write(KO,25) JTOT,PSIGN(IPAR+2)
25      format(//' Wave function for J,pi =',F5.1,a1/)

      IF(IPC.GE.5) WRITE(KO,*) 'Have:',LX,LY,LL,S,JNN,IC,JC,JTOT
C
      IF(IPC.GE.4)WRITE(KO,30) IA,LX,LY,LL,S,JNN,IC,JC,JTOT
30    FORMAT(' Input ch.',I3,' ( nos.',6i3,2f4.1,') ')
C
40      RV(1) = 0.0
        DO 50 IX=1,NRXY
	RV(IX) = (IX-1)*RSTEP
	read(NFL,*) IIX
50	READ(NFL,*) (V(IX,IY),IY=1,NRXY)
	XN = 0.0
        DO 53 IX=1,NRXY
        DO 53 IY=1,NRXY
	if(IVERT.eq.0) XN = XN + V(IX,IY)**2 * RSTEP**2
53	if(IVERT.gt.0) XN = XN + V(IX,IY) * RV(IX)*RV(IY)*RSTEP**2 *FPI

 	read(NFL,*) PNORM
      IF(IPC.GE.4) WRITE(KO,*) 'Input partial integral:',
     X			real(XN)
c     X			,real(PNORM)
      IF(IPC.eq.3)WRITE(KO,80) IA,LX,LY,LL,S,JNN,JC,XN
80    FORMAT(' Input ch.',I3,' ( lx,ly,L,S,JNN,JC=',3i3,',',2i3,f4.1,
     X		') mag =',f12.5)
	XNT = XNT + XN
      IF(IVERT.EQ.1) THEN
      open(1,file="cont",status='unknown')
	MP = NRXY/2
	 write(1,*) 0,real(RV(MP)),0,real(RV(MP))
	 write(1,*) MP,MP
       	  do 10 i = 1,MP
      	  do 10 j = 1,MP
 10 	  write(1,*) real(V(I,J))
	ENDIF
110   CONTINUE
120 	read(NFL,*) TNORM
      IF(IPC.GE.3) WRITE(KO,*) 'Input summed integrals:',
     X		real(TNORM),real(XNT)
200   CONTINUE
300      stop
      END
