
      SUBROUTINE TRAX(NTR,LV,JV,JJ,NPTY,NX,DX,YBS,NLAG,RR,
     1              IST,kk2,lltot2,sstot2,ll12,ll22,LNCMAX,NSTATE,
     2              NTARG,JTARG,JNN2,II2,PTARG,LDMIN,LDMAX,NZERO,MAXEQ,
     T              KIND,AC,AN,SN,WN1,NJAC,XJ,WJ,XL,PJ,
     3              MJAC,MX,MSS,NSMAX,MNM,MAXL,MLT,NMAX,
     5		    PRIPOT,EQN,MBS,ICV,JTV,KNF,KNL)
************************************************************************
*             TRANSFER STATES IN HH FADDEEV BASIS
************************************************************************
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      DOUBLEPRECISION YBS(MX, MBS)
      DOUBLEPRECISION JV(MBS),jamm,W9J(MSS,MAXEQ),
     1                WN1(NSMAX,NSMAX),JJ,JTARG(5),JTV(MBS),JC
      DIMENSION XJ(NJAC),WJ(NJAC),  XL(NLAG)
      DIMENSION PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC)
      INTEGER LV(MBS),NPTY,CHANS(NSMAX),KK2(NSMAX),JNN2(NSMAX),
     1 	      II2(NSMAX),PTARG(5),ICV(MBS),KNF(NTR),KNL(NTR),KIND(MBS),
     2        LL12(NSMAX),LL22(NSMAX),LLTOT2(NSMAX),SSTOT2(NSMAX)
      DIMENSION PHIB(NSMAX),PHIP(NSMAX),XNI(NSMAX)
      LOGICAL PRIPOT,NZERO(MSS),NZ
      CHARACTER EQN

	IF(NTR.eq.0) return
	NFIRST = 1
	NLAST  = NSTATE
	if(EQN.eq.'T') then
	   NFIRST = IST+1
	   NLAST  = NSTATE
	else if(EQN.eq.'Y') then
	   NFIRST = 1
	   NLAST  = IST
	endif 	
	NSTS   = NLAST-NFIRST+1
	if(EQN.ne.'F'.and.EQN.ne.'R') 
     x		write(6,*) ' Keeping transfers only in channels',
     x			NFIRST,' to ',NLAST
      IMIN=(NFIRST-1)*(NMAX+1) + 1
      IMAX=    NLAST *(NMAX+1)
c	IF(NTR.eq.0) return
      OPEN(27,ACCESS='SEQUENTIAL',STATUS='SCRATCH',FORM='UNFORMATTED')
	EPS = 0d0
	NCHP = NSTS
	do 5 i=1,NCHP
5	CHANS(i) = i
      Z=0d0
      ONE=1d0
C ***                factors multiplying x and y to give r and R (beta=Y)
C       amfacx = 1/sqrt(mu-cn),   amfacy = 1/sqrt(mu-(nc)n)
C
        amfacx=Sqrt((AC+AN)/(AC*AN))
        amfacy=Sqrt((AC+AN+AN)/((AC+AN)*AN))
	if(AC.gt.999.) then
           amfacx=Sqrt(1d0/AN)
           amfacy=Sqrt(1d0/AN)
	  endif
        xjac = amfacx**1.5
        hhjac = (amfacx*amfacy)**1.5
 
C ***                factors multiplying x and y to give r and R (alpha=T)
C       amfacxt = 1/sqrt(mu-nn),   amfacyt = 1/sqrt(mu-(nn)c)
C
        amfacxt=Sqrt((AN+AN)/(AN*AN))
        amfacyt=Sqrt((AC+AN+AN)/((AN+AN)*AC))
	if(AC.gt.999.) then
           amfacyt=Sqrt(1d0/(AN+AN))
	   endif
        xjact = amfacxt**1.5
        hhjact = (amfacxt*amfacyt)**1.5
        write(10,*) 'M factors x,y=',real(amfacx),real(amfacy),
     x                          real(hhjac),real(hhjact)
C
C  Scaling factor for normalisation
C	xjac for r -> x transformation Jacobean
C	1/sqrt(8d0) from PJ normalisation (with WJ),
C	
      SCAL =  ONE / sqrt(8d0) 
C 
c      do 400 IR=NLAG/2,NLAG,NLAG/8
      IR=NLAG
           RO=RR*XL(IR)
	   RO15 = RO**1.5d0

      NTRAN=0
      do 300 NIB=1,NTR
	IB1 = KNF(NIB)
	IB0 = IB1-1
	IB2 = KNL(NIB)
	if(KIND(NIB).lt.3) go to 300
	if(KIND(NIB).eq.3) then
C ****         Y transfer state  of sum(LV,JV,JC): (SV,LV)JV,JC;JTV  
C              with overall coupling (SV,LV)JV,JC;JTV + (lamm,SV)jamm  = JJ
	   samm = SN
	   INCOH = 1
	else
C ****         T transfer state  of sum(JV,L): (SN,SN)JV, L;JTV  
C              with overall coupling (SN,SN)JV, L;JTV + (JTARG,lamm)jamm  = JJ
	   INCOH = NTARG
	endif
       do 280 ICORE=1,INCOH
          if(KIND(NIB).eq.4) samm=JTARG(ICORE)
C 
C **** Now find allowed lamm, jamm:
       do 280 lamm=0,LNCMAX
       do 280 jamm=lamm-samm,lamm+samm
          if(jamm.lt.0.0) go to 280
          if(jamm.lt.abs(JTV(IB1)-JJ).or.jamm.gt.JTV(IB1)+JJ) go to 280
                ic = ICV(IB1)
                if(KIND(NIB).eq.4) ic = ICORE
          if((-1)**(lamm+LV(IB1))*PTARG(ic).ne.NPTY) go to 280

	do 15 ist1=1,NSTATE
	NZERO(ist1) = .false.
15	xni(ist1)=0.0
       do 22 IB=IB1,IB2
	M = IB-IB0
	ic = ICV(IB)
	JC = JTARG(ic)
       if(KIND(NIB).eq.3) then
C ****         Y transfer state  of sum(LV,JV,JC): (SV,LV)JV,JC;JTV  
C              with overall coupling (SV,LV)JV,JC;JTV + (lamm,SV)jamm  = JJ
       do 18 ist1=1,IST
        L = LLTOT2(ist1)
        LS= SSTOT2(ist1)
        Jnn= JNN2(ist1)
        W9J(ist1,M) = Z
           if(LV(IB).ne.LL12(ist1)) go to 18
           if(lamm  .ne.LL22(ist1)) go to 18
           if(ic    .ne.II2(ist1)) go to 18
           if((-1)**(lamm+LV(IB))*PTARG(ic).ne.NPTY) go to 18
       W9J(ist1,M) = sqrt((2*JV(IB)+1)*(2*jamm+1)*(2*L+1)*(2*LS+1))
     X           * sim9j(SN,   LV(IB)+Z,JV(IB),
     X                   SN,   lamm+Z,  jamm,
     X                   LS+Z, L+Z,     Jnn+Z) 
     X		 * sqrt((2*Jnn+1)*(2*JTV(IB)+1))
     X		 * RACAH(JC,JV(IB),JJ,jamm,JTV(IB),Jnn+Z)
     x		 * (-1) ** nint(JJ - JTV(IB) + JV(IB) - Jnn)
     X		 * SCAL
	NZERO(ist1) = NZERO(ist1).or.abs(W9J(ist1,M)).gt.1e-10
18     continue
	else
C ****         T transfer state  of sum(JV,L): (SN,SN)JV, L;JTV  
C              with overall coupling (SN,SN)JV,LV;JTV + (JTARG,lamm)jamm  = JJ
	ic = ICORE
       do 20 ist1=IST+1,NSTATE
        L = LLTOT2(ist1)
        LS= SSTOT2(ist1)
        Jnn= JNN2(ist1)
        W9J(ist1,M) = Z
c	write(10,*) 'W coefs(',ist1,M,') :'
           if(JV(IB).ne.LS) go to 20
           if(LV(IB).ne.LL12(ist1)) go to 20
           if(lamm  .ne.LL22(ist1)) go to 20
           if(ic    .ne.II2(ist1)) go to 20
           if((-1)**(lamm+LV(IB))*PTARG(ic).ne.NPTY) go to 20
       W9J(ist1,M) = sqrt((2*Jnn+1)*(2*jamm+1))
     X           *   sqrt((2*L+1)*(2*JTV(IB)+1))
     X		 * RACAH(JTV(IB),lamm+Z,JJ,JTARG(ic),Jnn+Z,jamm)
     X		 * RACAH(LS+Z,LV(IB)+Z,Jnn+Z,lamm+Z,JTV(IB),L+Z)
     x		 * (-1) ** nint(jamm - JTARG(ic)  - lamm)
     X		 * SCAL
c	write(10,*) 'W coefs(',ist1,M,') from'
c     X		 , RACAH(JTV(IB),lamm+Z,JJ,JTARG(ic),Jnn+Z,jamm)
c     X		 , RACAH(LS+Z,LV(IB)+Z,Jnn+Z,lamm+Z,JTV(IB),L+Z)
	NZERO(ist1) = NZERO(ist1).or.abs(W9J(ist1,M)).gt.1e-10
20     continue
	endif
22     continue
C
	NZ = .false.
	if(KIND(NIB).eq.3) then
         write(6,24) NIB,IB1,IB2,JTV(IB1),lamm,jamm,RO
         write(10,24) NIB,IB1,IB2,JTV(IB1),lamm,jamm,RO
24        format(/' Transfer states for b.s.',i2,' (',I2,' to',I3,
     X		', JTV =',f4.1,') with lamm,jamm =',I2,F5.1,
     X		' at RHO =',F8.3/)
	do 25 ist1=1,IST
25	NZ = NZ .or. NZERO(ist1)
	else
         write(6,26) NIB,IB1,IB2,JTV(IB1),lamm,JTARG(ic),jamm,RO
         write(10,26) NIB,IB1,IB2,JTV(IB1),lamm,JTARG(ic),jamm,RO
26        format(/' Transfer states for b.s.',i2,' (',I2,' to',I3,
     X		', JTV =',f4.1,') with lamm,JT,jamm =',I2,2F5.1,
     X		' at RHO =',F8.3/)
	do 28 ist1=IST+1,NSTATE
28	NZ = NZ .or. NZERO(ist1)
	endif
	if(.not.NZ) then
	 	write(6,*) ' All zero'
		go to 280
		endif
         NTRAN=NTRAN+1               
	    do 35 M=1,IB2-IB0
             write(6,30) M,(W9J(ist1,M)/SCAL,ist1=1,NSTATE)
             write(10,30) M,(W9J(ist1,M)/SCAL,ist1=1,NSTATE)
30           format(' W9J',I3,'=',10f7.4,:,/(8x,10f7.4))
35	    continue
	    write(6,36) (NZERO(ist1),ist1=1,NSTATE)
36	    format(' Chans neq 0:',30L2,:,/(13x,30L2))
         call flush(6)
	   do 40 ist2=NFIRST,NLAST
  40       PHIB(ist2) = 0.0
	if(KIND(NIB).eq.3) then
C ****         Y transfer state  of sum(LV,JV,JC): (SV,LV)JV,JC;JTV  
C              with overall coupling (SV,LV)JV,JC;JTV + (lamm,SV)jamm  = JJ
        do 90 ist1=1,IST       
           PHIB(ist1)=0.0
           if(.not.NZERO(ist1)) go to 90
	   L1=LL12(ist1)
	   L2=lamm
	   NN = mod(L1+L2,2)
	   LD=(L1-L2+NN)/2
	   N=(KK2(ist1)-L1-L2)/2
		if(LD.lt.LDMIN.or.LD.gt.LDMAX) go to 90
        do 70 M=1,NJAC
           xx = XJ(M)
           x = RO * SQRT((ONE-xx)*0.5d0)
           y = RO * SQRT((ONE+xx)*0.5d0)
           XP = x * amfacx
           YP = y * amfacy
           XR = XP/DX
             IX=XR
		IF(IX+1.gt.NX)  go to 70
             PX=XR-IX
             QX=1.-PX
           S = WJ(M) * PJ(N,L1,LD,M)  * RO15 * xjac
	    DO 60 IB=IB0+1,IB2
             USS=QX*YBS(IX+1,IB)+PX*YBS(IX+1+1,IB)
              T = S * USS * W9J(ist1,IB-IB0)
   60        PHIB(ist1) = PHIB(ist1) + T
   70    continue
   90    continue
c     X    write(10,92) RO,(PHIB(ist1),ist1=1,min(IST,7))
c   92   format(' RO=',f6.2,' PHIB =',7f9.4)
C 
	else
C ****         T transfer state  of sum(JV,L): (SN,SN)JV, L;JTV  
C              with overall coupling (SN,SN)JV, L;JTV + (JTARG,lamm)jamm  = JJ
        do 150 ist1=IST+1,NSTATE
           PHIB(ist1)=0.0
           if(.not.NZERO(ist1)) go to 150
	   L1=LL12(ist1)
	   L2=lamm
	   NN = mod(L1+L2,2)
	   LD=(L1-L2+NN)/2
	   N=(KK2(ist1)-L1-L2)/2
		if(LD.lt.LDMIN.or.LD.gt.LDMAX) go to 150
        do 140 M=1,NJAC
           xx = XJ(M)
           x = RO * SQRT((ONE-xx)*0.5d0)
           y = RO * SQRT((ONE+xx)*0.5d0)
           XP = x * amfacxt
           YP = y * amfacyt
           XR = XP/DX
             IX=XR
		IF(IX+1.gt.NX)  go to 140
             PX=XR-IX
             QX=1.-PX

           S = WJ(M) * PJ(N,L1,LD,M) * RO15 * xjact
	    DO 130 IB=IB0+1,IB2
             USS=QX*YBS(IX+1,IB)+PX*YBS(IX+1+1,IB)
              T = S * USS * W9J(ist1,IB-IB0)
  130        PHIB(ist1) = PHIB(ist1) + T
  140    continue
  150    continue
c     X    write(10,92) RO,(PHIB(ist1),ist1=1,min(IST,7))
C 
	endif
c	if(mod(ir,5).eq.0)
c    X    write(10,180) RO,(PHIB(ist1),ist1=1,min(IST,7))
c 180   format(' RO=',f6.2,' PHIB =',7f9.4)
  190 continue
C
c 
C 
C   Orthogonalise this state to all previous states:
      rewind 27
      DO 220 ITRAN=1,NTRAN-1
c     write(10,*) ' Read bc ',ITRAN,' for orthogonalisation'
      	read(27) (PHIP(ist2),ist2=NFIRST,NLAST)
      	xn=Z
	xna = 0.0
	xnb = 0.0
      	do 200 ist2=NFIRST,NLAST
      	t = PHIB(ist2)*PHIP(ist2) 
	xna = xna + PHIB(ist2)**2 
	xnb = xnb + PHIP(ist2)**2 
  200 	xn = xn + t
c     	xn = 0.0
      	if(abs(xn).gt.1e-10) then
      	   do 210 ist2=NFIRST,NLAST
  210 	   PHIB(ist2) = PHIB(ist2)  - xn * PHIP(ist2)
      	endif
      if(abs(xn).gt.0.01) write(10,215) NTRAN,ITRAN,xn,xna,xnb
  215 format('Overlap of state ',I3,' to ',I3,' =',g12.4,' Ns=',2f10.4)
  220 CONTINUE 

C 
C   Normalise this state:
      xn=Z
	NCHP = 0
      	do 250 ist2=NFIRST,NLAST
      	t = PHIB(ist2)**2 
      	xni(ist2) = t
	if(x.gt.EPS) then
	   NCHP = NCHP+1
	   CHANS(NCHP) = ist2
	endif
  250 	xn = xn + xni(ist2)
c     	write(6,1020) NTRAN,NIB,xn
      	write(6,1020) NTRAN,NIB,xn
     X         ,NCHP,(chans(ist2),xni(chans(ist2))/xn,ist2=1,NCHP)
      	write(10,1020) NTRAN,NIB,xn,NCHP,
     X              (chans(ist2),xni(chans(ist2)),ist2=1,NCHP)
 1020 format(' Asymp. state # ',I3,' from ',I3,' has norm ',G14.6,:,
     X',',I4,' >eps',:,' from partial waves:',/,(1x,6(i3,F10.5)))
	if(abs(xn).lt.1e-5) then
	   write(6,*) ' This state should be omitted'
	  endif
      t = 1d0/sqrt(xn)

C write cumulative set of transfer states to file 26, 
      write(26) (PHIB(ist2)*t,ist2=NFIRST,NLAST)
C
C Write set for current J-pi to file 27
c     write(10,*) ' Write bc ',ITRAN,' to file 27'
      write(27) (PHIB(ist2)*t,ist2=NFIRST,NLAST)

  280 continue
  300 continue
C			Include lower-K HH breakup channels, Y then T
      do 360 KCH=1,NSTATE-NTRAN
	NTRAN = NTRAN+1
        do 302 ist1=1,NSTATE
  302       PHIB(ist1)=0.0
c	PHIB(KTRAN(KCH)) = ONE
	PHIB(KCH) = ONE
c	if(KCH+IST.le.NSTATE) PHIB(KCH+IST) = ONE
c	if(KCH+IST.gt.NSTATE) PHIB(KCH) = ONE

C   Orthogonalise this state to all previous states:
      rewind 27
      DO 320 ITRAN=1,NTRAN-1
c     write(10,*) ' Read bc ',ITRAN,' for orthogonalisation'
      	read(27) (PHIP(ist2),ist2=NFIRST,NLAST)
      	xn=Z
	xna = 0.0
	xnb = 0.0
      	do 305 ist2=NFIRST,NLAST
      	t = PHIB(ist2)*PHIP(ist2) 
	xna = xna + PHIB(ist2)**2 
	xnb = xnb + PHIP(ist2)**2 
  305 	xn = xn + t
c     	xn = 0.0
      	if(abs(xn).gt.1e-10) then
      	   do 310 ist2=NFIRST,NLAST
  310 	   PHIB(ist2) = PHIB(ist2)  - xn * PHIP(ist2)
      	endif
c      if(abs(xn).gt.0.01)
	 write(10,215) NTRAN,ITRAN,xn,xna,xnb
  320 CONTINUE 

C 
C   Normalise this state:
      xn=Z
	NCHP = 0
      	do 350 ist2=NFIRST,NLAST
      	t = PHIB(ist2)**2 
      	xni(ist2) = t
	if(x.gt.EPS) then
	   NCHP = NCHP+1
	   CHANS(NCHP) = ist2
	endif
  350 	xn = xn + xni(ist2)
c     	write(6,1020) NTRAN,KCH,xn
      	write(6,1020) NTRAN,KCH,xn
c    X        NCHP,(chans(ist2),xni(chans(ist2))/xn,ist2=1,NCHP)
      	write(10,1020) NTRAN,KCH,xn,NCHP,
     X              (chans(ist2),xni(chans(ist2)),ist2=1,NCHP)
      t = 1d0/sqrt(xn)

C write cumulative set of transfer states to file 26, 
      write(26) (PHIB(ist2)*t,ist2=NFIRST,NLAST)
C
C Write set for current J-pi to file 27
c     write(10,*) ' Write bc ',ITRAN,' to file 27'
      write(27) (PHIB(ist2)*t,ist2=NFIRST,NLAST)

  360 continue
	
  400 continue
      rewind 27
      return
      end
