      SUBROUTINE VERTEX(JTOT,PTY,AC,AN,WJ,XJ,PJ,WN1,MP12,EQN,MKMAX,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x     JTARG,JNN3,II3,JNN2,II2, XL,WL,RR,RL,MNMAX,RINNER,IMAX,H2M,
     x	   WW, MLAG,MJAC,MCH,MAXL,MLNN,MAXL2, MNM,MLT,MLNC,MLL,MEIGS,
     x     NLAG,NJAC,IMAX2,IMAX3,LNNMAX,L1MAX,L2MAX,LNCMAX,SMAX,NM,
     x     NN,LDMIN,LDMAX,isr,nfound,fpot,MONOPEX,
     X     VECSR,VALR,CTN,DTN,KKN,ICN,IFO,FESH,wfnrr)


      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'actives.f'
	integer dp 
	parameter(dp = selected_real_kind(12))

      DIMENSION WJ(MJAC),XJ(MJAC)
      DIMENSION PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC),CHNM(MCH),CHNNN(MCH),
     &          WN1(MCH,MCH),MP12(MCH), XL(NLAG),WL(NLAG)
      INTEGER KK3(MCH),LL13(MCH),LL23(MCH),LLTOT3(MCH),SSTOT3(MCH),
     &        KK2(MCH),LL12(MCH),LL22(MCH),LLTOT2(MCH),SSTOT2(MCH),
     &        JNN3(MCH),II3(MCH),JNN2(MCH),II2(MCH),IFO(MCH,3)
      DOUBLE PRECISION JTARG(NTARG),ETARG(10),JTOT,KTARG

      DIMENSION WW(MCH,MCH,MLAG),RL(0:MNMAX,NLAG)
      DIMENSION VECSR(MLL,MEIGS),VALR(MEIGS),isr(nfound),pvec(MLL)
      DIMENSION KKN(MCH),ICN(MCH),CTN(MCH,MCH),DTN(MCH,MCH)

	INTEGER TT,PTY,SMAX
	COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5),BETA(2:5),
     X			VOLCON,CONS,QQ(2:5)
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
	CHARACTER PSIGN(3),EQN,BASES(36:39)
	CHARACTER*80 fpot
      	real(KIND=dp) EN(-1:MAXACT,-1:MAXLVACT)

        real(kind=dp),allocatable:: tj(:),FC(:),BESSJ(:,:),
     X         CHIP(:,:),WFNX(:)
	
      	LOGICAL VOLCON,CONS,l1l,l2l,l3l,l4l,FESH,havech,wfnrr
      	DATA PSIGN / '-',' ','+' /, BASES/3*'T','Y'/

      allocate(tj(MJAC),FC(MKMAX+2),BESSJ(MKMAX+2,NTARG))
c				Analyze the output bound states,
C				using RL(*,*) G-Laguerre basis fntns

!  PARAMETERS FOR CALCULATIONS:
	thresh = 1e-4
	lvertmax = 6
        rstep = 0.2
	nrxy  = 40.0/rstep

	if(thresh>0.) write(6,*) ' COMPONENT THRESHOLD =',thresh
	INIT = .false.
	IMAXH = IMAX
		write(10,*)  ' VERTEX: nfound =',nfound
	do 2000 ifound=1,min(500,nfound)
	iv = isr(ifound)
        if(EQN.eq.'N'.or.wfnrr) go to 900
	write(6,810) iv,valr(iv)
	write(10,810) iv,valr(iv)
810	format(/' Analyzing eigenenergy of state',I3,' at',F11.6,
     x		' MeV')
	if(EQN.eq.'T') then
C			Restore Y,T quantum numbers to before S reduction:
	  rewind 8
	  read(8,*) IMAX2,IMAX3
	  do 386 I=1,IMAX2
          read(8,*) II,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I)
386       write(10,*) i,II,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I), 'Y'
	  do 387 I=1,IMAX3
          read(8,*) II,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(I)
387       write(10,*) i,II,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(I), 'T'
	  do I=1,IMAX3
	   KK2(IMAX2+I) = KK3(I)
	   LL12(IMAX2+I) = LL13(I)
	   LL22(IMAX2+I) = LL23(I)
	   lltot2(IMAX2+I) = lltot3(I)
	   sstot2(IMAX2+I) = sstot3(I)
	   JNN2(IMAX2+I) = JNN3(I)
	   II2(IMAX2+I) = II3(I)
	  enddo
	  IMAXH = IMAX2 + IMAX3
	  do 390 i=1,imaxh
	  write(10,*) 'NEW',i,KK2(i),LLTOT2(i),SSTOT2(i),ll12(i),ll22(i)
390	  continue
	 endif
	ENGY = 0.0
	do 870 IACT=-1,MAXACT
	do 870 LVACT=-1,min(MAXLVACT,MLVACT(IACT))
	write(110,*) 
	write(110,*) 'IACT,WHACT,LVACT =',IACT,WHACT(IACT),LVACT
	do 815 I=1,MAXACT
815	ACTIVE(I)=.false.
	if(IACT.ge.1) then
	 ACTIVE(IACT) = .true.

	 CALL FADCOX(JTOT,AC,AN,WJ,XJ,PJ,WN1,MP12,EQN,MKMAX,RINNER,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x     JTARG,JNN3,II3,JNN2,II2, XL,RR,.true.,
     x	   WW, MLAG,MJAC,MCH,MAXL,MLNN,MAXL2, MNM,MLT,MLNC,
     x     NLAG,NJAC,IMAX2,IMAX3,LNNMAX,L1MAX,L2MAX,LNCMAX,NM,
     x     NN,LDMIN,LDMAX,MONOPEX)

          CALL REDHAM(EQN,WN1,WW,MCH,NLAG, CTN,DTN,KKN,ICN,
     x	   	KK2,II2,IMAX2,IMAX3,IMAX,IMAX2H,IMAX3H,IMAXH,.false.)
	else
	  if(EQN.eq.'T') IMAXH = IMAX3
	  if(EQN.eq.'Y') IMAXH = IMAX2
	endif

	EN(IACT,LVACT) = 0.0
C THE MATRIX ELEMENTS
        HH=H2M/(RR*RR)
        DO 821 I=1,IMAXH
        DO 822 N=0,MNMAX
        II=(MNMAX+1)*(I-1)+N+1
        DO 823 I1=1,IMAXH
        DO 824 N1=0,MNMAX
        II1=(MNMAX+1)*(I1-1)+N1+1
        S=0.
	if(IACT.ge.1) then
           DO 825 J=1,NLAG
825         S=S+RL(N,J)*RL(N1,J)*WW(I,I1,J)*WL(J)
	else if(IACT.eq.-1) then
           K=KK2(I)
	   if(EQN.eq.'T') K=KK3(I)
           IF(I.EQ.I1)   S=EKIN(N,N1,K)*HH
		if(LVACT.ge.0.and.LL12(I).ne.LVACT) S=0.0
	else if(IACT.eq.0) then
	   IC=II2(I)
	   if(EQN.eq.'T') IC=II3(I)
           IF(II.EQ.II1) S=ETARG(IC)
		if(LVACT.ge.0.and.LL12(I).ne.LVACT) S=0.0
	endif
	Z1 = S * VECSR(II,iv) * VECSR(II1,iv)
	EN(IACT,LVACT) = EN(IACT,LVACT) + Z1
824      CONTINUE
823      CONTINUE
822      CONTINUE
821      CONTINUE

	if(LVACT.lt.0) ENGY = ENGY + EN(IACT,LVACT)
	write(10,850) WHACT(IACT),LVACT,EN(IACT,LVACT)
850	format(' Contribution from ',A6,' @ L =',I1,'  = ',F12.6)
870	continue
	write(10,850) 'all',-1,ENGY
	write(6,880) ((WHACT(IACT),LVACT,EN(IACT,LVACT),
     X     LVACT=-1,min(MAXLVACT,MLVACT(IACT))),IACT=-1,MAXACT),
     X     'all',-1,ENGY
880	format(3(' from ',A6,'_',I1,F10.6,:,','))

c---------------------------------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	Calculate and write wave functions and vertex functions of various types
900	continue !if(EQN.ne.'T'.and.EQN.ne.'N') go to 1980
	ifmax = 38
	if(EQN.eq.'F') ifmax = 39
	
	write(6,901) iv,valr(iv),fpot(1:lnblnk(fpot))//'.vha'
901	format(/' Finding vertex functions of state',I5,' at',F11.6,
     x		' MeV in files 37,38:',a30)
	NLR = NLAG
        allocate(CHIP(NLR,MCH))

	write(37,902) JTOT,PSIGN(PTY+2),iv
902	format('#',f5.1,a1,' state:  Wfn & Vertex fn  #',i2)
	write(37,903) valr(iv),H2M,AC,AN,AN
	write(37,'(''#'',i4,'' hyperradial points, at:'')') NLR
	write(37,903) (RR*XL(J),J=1,NLR)
903	format('#',6f10.5)
	write(37,'(''#'',i4,'' hyperangular points at cos(2a)='')') NJAC
	write(37,903) (XJ(J),J=1,NJAC)
	call flush(37)
c					Plot in rectangular grid
	allocate (WFNX(nrxy))
	do ii=38,ifmax
	  write(ii,'(i4,f10.5,i4,f10.5)') nrxy,rstep,-1,valr(iv)
	  call flush(ii)
	enddo
	fpi = 4d0*atan(1d0) * 4d0
	mvert=2
	if(wfnrr) mvert=0
	do 1970 ivert=0,mvert
	IMAXH = IMAX
	if(EQN.eq.'T') then
C			Restore Y,T quantum numbers to before S reduction:
	  rewind 8
	  read(8,*) IMAX2,IMAX3
	  do 905 I=1,IMAX2
905       read(8,*) II,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I)
	  do 907 I=1,IMAX3
907       read(8,*) II,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(I)
	  do I=1,IMAX3
	   KK2(IMAX2+I) = KK3(I)
	   LL12(IMAX2+I) = LL13(I)
	   LL22(IMAX2+I) = LL23(I)
	   lltot2(IMAX2+I) = lltot3(I)
	   sstot2(IMAX2+I) = sstot3(I)
	   JNN2(IMAX2+I) = JNN3(I)
	   II2(IMAX2+I) = II3(I)
	  enddo
	  IMAXH = IMAX2 + IMAX3
! 	  write(6,*) '1: IMAX2,IMAX3,IMAXH=',IMAX2,IMAX3,IMAXH
	 endif
	do ii=36,ifmax
	 iii=ii
	 if(ii.eq.36) iii=6
	write(iii,'(''#'')')
	if (ivert.eq.0) 
     x      write(iii,'(''# '',A1,'' Wave function'')') BASES(ii)
	if (ivert.eq.1) 
     X      write(iii,'(''# (Vn1c+Vn2c+V3) * wf: transfers'')')
	if (ivert.eq.2) write(iii,'(''# (all Vs) * wf: breakup'')')
	enddo
	do 908 I=1,MAXACT
908	ACTIVE(I)=.false.
	LVACT = -1
	if(ivert.ge.1) then
        
	    ACTIVE(LNCC) = ivert.ge.1
	    ACTIVE(LNCLS) = ivert.ge.1
	    ACTIVE(LNCLSC) = ivert.ge.1
	    ACTIVE(LNCLL) = ivert.ge.1
	    ACTIVE(LNCT) = ivert.ge.1
	    ACTIVE(LNCDEF) = ivert.ge.1

	    ACTIVE(LNN3B) = ivert.ge.1
	    ACTIVE(LNC3B) = ivert.ge.1
	  
	    ACTIVE(LNNC) = ivert.ge.2
	    ACTIVE(LNNLS) = ivert.ge.2
	    ACTIVE(LNNLL) = ivert.ge.2
	    ACTIVE(LNNT) = ivert.ge.2

	 CALL FADCOX(JTOT,AC,AN,WJ,XJ,PJ,WN1,MP12,EQN,MKMAX,RINNER,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x     JTARG,JNN3,II3,JNN2,II2, XL,RR,.true.,
     x	   WW, MLAG,MJAC,MCH,MAXL,MLNN,MAXL2, MNM,MLT,MLNC,
     x     NLAG,NJAC,IMAX2,IMAX3,LNNMAX,L1MAX,L2MAX,LNCMAX,NM,
     x     NN,LDMIN,LDMAX)

          CALL REDHAM(EQN,WN1,WW,MCH,NLAG, CTN,DTN,KKN,ICN,
     x	   	KK2,II2,IMAX2,IMAX3,IMAX,IMAX2H,IMAX3H,IMAXH,.false.)
	else
	  if(EQN.eq.'F') then
	     IMAXH = IMAX
	     IMAX2H = IMAX2
	     IMAX3H = IMAX3     
	  else if(EQN.eq.'T') then
	     IMAXH = IMAX3
	     IMAX2H = 0
	     IMAX3H = IMAX3     
	  else if(EQN.eq.'Y') then
	     IMAXH = IMAX2
	     IMAX2H = IMAX2
	     IMAX3H = 0
	  endif     
	endif
C				Project onto basis states, if not already
        if(EQN.eq.'F') then
        S2 = 0.0
        DO 534 I=1,IMAX
         XZ = 1.0
         if(I<=IMAX2) XZ=0.5
        DO 534 N=0,MNMAX
        II=(MNMAX+1)*(I-1)+N+1
        S=0.
          if(FESH.and.IFO(I,3)==0) go to 534
        DO 532 I1=1,IMAX
        N1=N
        II1=(MNMAX+1)*(I1-1)+N1+1
          if(FESH) II1=(MNMAX+1)*(IFO(I1,3)-1)+N1+1
532     S=S+WN1(I,I1)*vecsr(II1,iv)
        S2 = S2 + S*vecsr(II,iv)
534     pvec(II) = S * XZ
	vecsr(:,iv) = pvec(:)
	write(6,*) ' Faddeev eigenstate normalisation  = ',real(S2)
	endif

C					Wfn
	VN = 0.0
	DO 913 J=1,NLR
        DO 910 I=1,IMAXH
	  S2 = 0.0
          if(FESH.and.EQN.ne.'N'.and.IFO(I,3)==0) go to 910
        DO 909 N=0,MNMAX
        II=(MNMAX+1)*(I-1)+N+1
        if(FESH.and.EQN.ne.'N') II=(MNMAX+1)*(IFO(I,3)-1)+N+1
909	  S2 = S2 + VECSR(II,iv) * RL(N,J)
910     CHNM(I) = S2/sqrt(RR)
	DO 913 I=1,IMAXH
	 if(ivert.eq.0) then
C					Wave function only
           S2 = CHNM(I)
	   VN = VN + S2**2* WL(J)*RR
	 else 
C					Potential * wave function 
	   S2 = 0.0
	   DO 912 I2=1,IMAXH
912        S2 = S2 + WW(I,I2,J)*CHNM(I2)
	  VN = VN + CHNM(I)*S2 * WL(J)*RR
	 endif
	 CHIP(J,I) = S2
913     continue
	CHNNN(:) = 0.
	do J=1,NLR
	do I=1,IMAXH
	CHNNN(I) = CHNNN(I) + CHIP(J,I)**2 * WL(J)*RR
	enddo
	enddo
!	write(6,*) ' Sq. norms of components of CHIP wave function:'
!	write(6,9135) (I,CHNNN(I),I=1,IMAXH)
!9135	format(6(i3,f8.5,','))
!	write(6,*) ' using IFO(:,3) =',IFO(1:IMAXH,3)
!	write(6,*) ' with  IFO(:,1) =',IFO(1:IMAXH,1)
	if(ivert.eq.0) write(6,'(''# Wf norm ='',f10.4)') VN
	if(ivert.ge.1) write(6,'(''# Vertex me ='',f10.4)') VN
*	if(ivert.ge.1) then
*	VN = 0.0
*C THE MATRIX ELEMENTS
*        DO 1824 I=1,IMAXH
*        DO 1824 N=0,MNMAX
*        II=(MNMAX+1)*(I-1)+N+1
*        DO 1824 I1=1,IMAXH
*        DO 1824 N1=0,MNMAX
*        II1=(MNMAX+1)*(I1-1)+N1+1
*        S=0.
*           DO 1825 J=1,NLR
*1825         S=S+RL(N,J)*RL(N1,J)*WW(I,I1,J)*WL(J)
*	Z1 = S * VECSR(II,iv) * VECSR(II1,iv)
*	VN = VN + Z1
*1824      CONTINUE
*	write(6,'(''# Vertex me 2 ='',f10.4)') VN
*	endif
C					Hyperradius & hyperangle T basis
	write(6,*) 'LNCMAX,LNNMAX,L2MAX,SMAX,NTARG,JTOT,JTARG(1) =',
     x		LNCMAX,LNNMAX,L2MAX,SMAX,NTARG,JTOT,JTARG(1)
 	write(6,*) 'RR =',RR,' MNMAX =',MNMAX,'  EQN =',EQN
 	write(6,*) 'IMAX2,IMAX3 =',IMAX2,IMAX3
 	write(6,*) 'IMAX2H,IMAX3H,IMAXH,NLR =',IMAX2H,IMAX3H,IMAXH,NLR
	TN = 0.0
        DO 950 LL1=0,min(lvertmax,max(LNCMAX,LNNMAX))
	DO 950 LL2=0,L2MAX
	DO 950 LL=0,LL1+LL2
	DO 950 ISS=0,SMAX
	DO 950 IC=1,NTARG
	DO 950 JNN=nint(abs(JTOT-JTARG(IC))),nint(JTOT+JTARG(IC))
	if(LL.lt.abs(ISS-JNN).or.LL.gt.ISS+JNN) go to 950
	  havech = .false.
	U = 0.0
        DO 928 J=1,NLR
	  RHO=RR*XL(J)
	  do 914 ITH=1,NJAC
914	  TJ(ITH) = 0.0
        DO 925 I=1,IMAX3H
          if(LL1.ne.LL13(I)) go to 925
          if(LL2.ne.LL23(I)) go to 925
          if(ISS.ne.SSTOT3(I)) go to 925
          if(IC.ne.II3(I)) go to 925
          if(LL.ne.LLTOT3(I)) go to 925
          if(JNN.ne.JNN3(I)) go to 925
          NN = mod(LL1+LL2,2)
          LD=(LL1-LL2+NN)/2
          N=(KK3(I)-LL1-LL2)/2
	do ii=6,37,31
	if(.not.havech) 
     X		write(ii,915) LL1,LL2,LL,ISS,JNN,IC,JTARG(IC),JTOT
915	format('#  ',6i3,2f4.1,' : L1,L2,L,S,Jnn,I#,I,JT ')
	call flush(ii)
	enddo
	  havech = .true.
!	  if(J.eq.1) write(6,*) ' Contribution from T channels ',I
          S2 = CHIP(J,I+IMAX2H)
	  S2 = S2 * sqrt(8d0)
	DO 920 ITH=1,NJAC
920	  TJ(ITH) = TJ(ITH) + S2 * PJ(N,LL1,LD,ITH)
925	continue
        if(havech) then
	  write(37,927) RHO,(TJ(ITH),ITH=1,NJAC)
	  do 926 ITH=1,NJAC
	  if(ivert.eq.0) U = U + TJ(ITH)**2 * WJ(ITH)/8d0 * WL(J)*RR
926	  if(ivert.ge.1) U = U + TJ(ITH) * WJ(ITH)/8d0 * WL(J)*RR * fpi
	  endif
927	format(f8.3,1p,5e13.5,:,/('#',7x,5e13.5,:))
928	continue
	if(.not.havech) go to 950
	do ii=6,37,31
	if(ivert.eq.0) write(ii,'(''# Sq.norm ='',f10.6)') U
	if(ivert.ge.1) write(ii,'(''# Volume integral ='',f10.4)') U
	enddo
	write(37,*) '&'
c
	if(U<thresh) go to 950
c					Plot in rectangular grid
	write(38,915) LL1,LL2,LL,ISS,JNN,IC,JTARG(IC),JTOT
c
	do 930 ith=1,njac
930	  tj(ith) = 0.5d0*acos(XJ(ith))
C ***                factors multiplying x and y to give r and R (alpha=T)
C       amfacxt = 1/sqrt(mu-nn),   amfacyt = 1/sqrt(mu-(nn)c)
C
        amfacxt=Sqrt((AN+AN)/(AN*AN))
        amfacyt=Sqrt((AC+AN+AN)/((AN+AN)*AC))
	if(AC.gt.999.) then
           amfacyt=Sqrt(1d0/(AN+AN))
	   endif
        hhjact = (amfacxt*amfacyt)**1.5
	pnorm=0.d0
	do 945 irx=1,nrxy
	rrx=irx*rstep
	 rx = rrx/amfacxt
	 write(38,*) irx
	do 940 iry=1,nrxy
	rry=iry*rstep
	 ry = rry/amfacyt
	  RHO=sqrt(rx*rx+ry*ry)
	  rr25=sqrt(8d0)/RHO**2.5d0/hhjact
	  jrr=1
	  do j=1,NLR-1
	   if (RHO.ge.RR*XL(j)) jrr=j
	  enddo
	  drrx=(RHO-RR*XL(jrr))/(RR*XL(jrr+1)-RR*XL(jrr))
	  drry=1.d0-drrx
	  thet=atan(rx/ry)
	  jthet=1
	  do j=1,njac-1
	   if (thet.ge.tj(j)) jthet=j
	  enddo
	  dthetx=(thet-tj(jthet))/(tj(jthet+1)-tj(jthet))
	  dthety=1.d0-dthetx
	  l1l=jthet.ne.0
	  l2l=jthet.ne.njac
	  l3l=jrr.ne.0
	  l4l=jrr.ne.NLR
	    at1=0.d0
	    at2=0.d0
	    at3=0.d0
	    at4=0.d0
	  CHIPxy=0.0
          DO 935 I=1,IMAX3H
          if(LL1.ne.LL13(I)) go to 935
          if(LL2.ne.LL23(I)) go to 935
          if(ISS.ne.SSTOT3(I)) go to 935
          if(IC.ne.II3(I)) go to 935
          if(LL.ne.LLTOT3(I)) go to 935
          if(JNN.ne.JNN3(I)) go to 935
!	  if(irx.eq.1.and.iry.eq.1) 
!     x		write(6,*) ' RR Contribution from Y channel ',I
          NN = mod(LL1+LL2,2)
          LD=(LL1-LL2+NN)/2
          N=(KK3(I)-LL1-LL2)/2
	  if(l1l.and.l3l) at1=dthety*CHIP(jrr,I+IMAX2H)
     X				*PJ(N,LL1,LD,jthet) 
	  if(l2l.and.l3l) at2=dthetx*CHIP(jrr,I+IMAX2H)
     X				*PJ(N,LL1,LD,jthet+1)
	  if(l1l.and.l4l) at3=dthety*CHIP(jrr+1,I+IMAX2H)
     X				*PJ(N,LL1,LD,jthet)
	  if(l2l.and.l4l) at4=dthetx*CHIP(jrr+1,I+IMAX2H)
     X				*PJ(N,LL1,LD,jthet+1)
	    CHIPxy=CHIPxy+(drry*(at1+at2)+drrx*(at3+at4))*rr25*rrx*rry
935	    continue
	    WFNX(iry) = CHIPxy
	  if(ivert.eq.0) Pnorm=Pnorm+CHIPxy**2 * rstep**2
	  if(ivert.ge.1) Pnorm=Pnorm+CHIPxy    * rstep**2 * fpi*rry*rrx
940     continue
	write(38,942) (WFNX(iry),iry=1,nrxy)
942     format(1p,6e12.4)
945	continue
	TN = TN + Pnorm
	do 948 ii=6,38,32
	if(ivert.eq.0) write(ii,'(f10.6,'' = Sq.xy norm'')') Pnorm
948	if(ivert.ge.1) write(ii,'(f10.2,'' = xy Volume int'')') Pnorm
950	continue
	write(37,915) -1
	write(38,915) -1
	do 960 ii=6,38,32
	if(ivert.eq.0) write(ii,'(f10.6,'' = Total Sq.xy norm'')') TN
    	if(ivert.ge.1) write(ii,'(f10.2,'' = Total xy Volume int'')')TN
960	call flush(ii)


C					Hyperradius & hyperangle Y basis
	if(EQN.eq.'F') then
	write(6,*)
	write(6,*) ' Radial wave functions in Y basis:'
	TN = 0.0
        DO 1950 LL1=0,min(lvertmax,max(LNCMAX,LNNMAX))
	DO 1950 LL2=0,L2MAX
	DO 1950 LL=0,LL1+LL2
	DO 1950 ISS=0,SMAX
	DO 1950 IC=1,NTARG
	DO 1950 JNN=nint(abs(JTOT-JTARG(IC))),nint(JTOT+JTARG(IC))
	if(LL.lt.abs(ISS-JNN).or.LL.gt.ISS+JNN) go to 1950
	  havech = .false.
	U = 0.0
        DO 1928 J=1,NLR
	  RHO=RR*XL(J)
 	  TJ(1:NJAC) = 0.0
        DO 1925 I=1,IMAX2H
          if(LL1.ne.LL12(I)) go to 1925
          if(LL2.ne.LL22(I)) go to 1925
          if(ISS.ne.SSTOT2(I)) go to 1925
          if(IC.ne.II2(I)) go to 1925
          if(LL.ne.LLTOT2(I)) go to 1925
          if(JNN.ne.JNN2(I)) go to 1925
          NN = mod(LL1+LL2,2)
          LD=(LL1-LL2+NN)/2
          N=(KK2(I)-LL1-LL2)/2
	do ii=6,6,31
	if(.not.havech) 
     X		write(ii,915) LL1,LL2,LL,ISS,JNN,IC,JTARG(IC),JTOT
	call flush(ii)
	enddo
	  havech = .true.
!	  if(J.eq.1) write(6,*) ' Contribution from Y channel ',I
          S2 = CHIP(J,I)
	  S2 = S2 * sqrt(8d0)
 	  TJ(1:NJAC) = TJ(1:NJAC) + S2 * PJ(N,LL1,LD,1:NJAC)
1925	continue
        if(havech) then
	  do 1926 ITH=1,NJAC
	  if(ivert.eq.0) U = U + TJ(ITH)**2 * WJ(ITH)/8d0 * WL(J)*RR
1926	  if(ivert.ge.1) U = U + TJ(ITH) * WJ(ITH)/8d0 * WL(J)*RR * fpi
	  endif
1928	continue
	if(.not.havech) go to 1950
	do ii=6,6,31
	if(ivert.eq.0) write(ii,'(''# Sq.norm ='',f10.6)') U
	if(ivert.ge.1) write(ii,'(''# Volume integral ='',f10.4)') U
	enddo
c
	if(U<thresh) go to 1950
c					Plot in rectangular grid
	write(39,915) LL1,LL2,LL,ISS,JNN,IC,JTARG(IC),JTOT
c
 	  tj(1:NJAC) = 0.5d0*acos(XJ(1:NJAC))
C ***                factors multiplying x and y to give rnc and Rn(nc) (beta=Y)
C       amfacxy = 1/sqrt(mu-nc),   amfacyy = 1/sqrt(mu-(nc)n)
C
        amfacxy=Sqrt((AC+AN)/(AC*AN))
        amfacyy=Sqrt((AC+AN+AN)/((AN+AC)*AN))
	if(AC.gt.999.) then
           amfacyy=Sqrt(1d0/AN)
	   endif
        hhjact = (amfacxy*amfacyy)**1.5
	pnorm=0.d0
	do 1945 irx=1,nrxy
	rrx=irx*rstep
	 rx = rrx/amfacxy
	 write(39,*) irx
	do 1940 iry=1,nrxy
	rry=iry*rstep
	 ry = rry/amfacyy
	  RHO=sqrt(rx*rx+ry*ry)
	  rr25=sqrt(8d0)/RHO**2.5d0/hhjact
	  jrr=1
	  do j=1,NLR-1
	   if (RHO.ge.RR*XL(j)) jrr=j
	  enddo
	  drrx=(RHO-RR*XL(jrr))/(RR*XL(jrr+1)-RR*XL(jrr))
	  drry=1.d0-drrx
	  thet=atan(rx/ry)
	  jthet=1
	  do j=1,njac-1
	   if (thet.ge.tj(j)) jthet=j
	  enddo
	  dthetx=(thet-tj(jthet))/(tj(jthet+1)-tj(jthet))
	  dthety=1.d0-dthetx
	  l1l=jthet.ne.0
	  l2l=jthet.ne.njac
	  l3l=jrr.ne.0
	  l4l=jrr.ne.NLR
	    at1=0.d0
	    at2=0.d0
	    at3=0.d0
	    at4=0.d0
	  CHIPxy=0.0
          DO 1935 I=1,IMAX2H
          if(LL1.ne.LL12(I)) go to 1935
          if(LL2.ne.LL22(I)) go to 1935
          if(ISS.ne.SSTOT2(I)) go to 1935
          if(IC.ne.II2(I)) go to 1935
          if(LL.ne.LLTOT2(I)) go to 1935
          if(JNN.ne.JNN2(I)) go to 1935
!	  if(J.eq.1) write(6,*) ' RR Contribution from Y channel ',I
          NN = mod(LL1+LL2,2)
          LD=(LL1-LL2+NN)/2
          N=(KK2(I)-LL1-LL2)/2
	  if(l1l.and.l3l) at1=dthety*CHIP(jrr,I)*PJ(N,LL1,LD,jthet) 
	  if(l2l.and.l3l) at2=dthetx*CHIP(jrr,I)*PJ(N,LL1,LD,jthet+1)
	  if(l1l.and.l4l) at3=dthety*CHIP(jrr+1,I)*PJ(N,LL1,LD,jthet)
	  if(l2l.and.l4l) at4=dthetx*CHIP(jrr+1,I)*PJ(N,LL1,LD,jthet+1)
	    CHIPxy=CHIPxy+(drry*(at1+at2)+drrx*(at3+at4))*rr25*rrx*rry
1935	    continue
	    WFNX(iry) = CHIPxy
	  if(ivert.eq.0) Pnorm=Pnorm+CHIPxy**2 * rstep**2
	  if(ivert.ge.1) Pnorm=Pnorm+CHIPxy    * rstep**2 * fpi*rry*rrx
1940     continue
	write(39,942) (WFNX(iry),iry=1,nrxy)
1945	continue
	TN = TN + Pnorm
	do 1948 ii=6,39,33
	if(ivert.eq.0) write(ii,'(f10.6,'' = Sq.xy norm'')') Pnorm
1948	if(ivert.ge.1) write(ii,'(f10.2,'' = xy Volume int'')') Pnorm
1950	continue
	write(39,915) -1
	do 1960 ii=6,39,33
	if(ivert.eq.0) write(ii,'(f10.6,'' = Total Sq.xy norm'')') TN
    	if(ivert.ge.1) write(ii,'(f10.2,'' = Total xy Volume int'')')TN
1960	call flush(ii)
	endif
1970  	continue
	deallocate (WFNX,CHIP)
1980  	continue
2000	continue

        deallocate(tj,FC,BESSJ)
	return
	end
