C
C			n-alpha potential from Shirokov et al.
C
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	        V = 0.0
		if(L.le.1) V=-47.32
		if(L.ge.2) V=-8.00
		uc=V*ddexp(-(r/2.30d0)**2)
		RETURN
	ENTRY ULS(L,R)
		if(L.le.1) VLS=-11.675
		if(L.ge.2) VLS=-1.974
		s=ddexp(-(r/2.30d0)**2)
		uls=VLS*s
		RETURN
	ENTRY ULSC(L,R)
		ULSC = 0d0
		RETURN
	ENTRY ULL(L,R)
		ULL = 0d0
		RETURN
	ENTRY UT(L,R)
		UT = 0d0
		RETURN
	END
