C****
C**** GPT POTENTIEL DE D. Gogny, P. Pires and R. de Tourreil,
C****                 Phys. Lett.  32B (1970) 591
C****     1S0 scattering length = -22.12 fm
C****	  with p+p coulomb potential screened at RSCR

	FUNCTION VC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
	VCOUL = 1.44D0/R 
	if(RSCR>.0) VCOUL = VCOUL *DEXP(-(R/RSCR)**2)
	VC=0D0
	IF(L.EQ.0) THEN
C                           #######   nn s-wave
            ON1=R**2/0.8109**2
            PUH1=560.0*DDEXP(-ON1)
            ON2=R**2/1.031**2
            PUH2=-390.7*DDEXP(-ON2)
            ON3=R**2/3.205**2
            PUH3=-1.501*DDEXP(-ON3)
      	     VC=PUH1+PUH2+PUH3
	ELSE IF(L.EQ.1) THEN
c   ##########   nn p-wave
           ON1=R**2/1.184**2
           PUH1=9.335*DDEXP(-ON1)
           ON2=R**2/2.099**2
           PUH2=-1.37*DDEXP(-ON2)
           ON3=R**2/3.193**2
           PUH3=0.1663*DDEXP(-ON3)
           VC=PUH1+PUH2+PUH3
	ELSE IF(L.EQ.2) THEN
c  ############## nn d-wave
           ON1=R**2/0.8109**2
           PUH1=560.0*DDEXP(-ON1)
           ON2=R**2/1.031**2
           PUH2=-390.7*DDEXP(-ON2)
           ON3=R**2/3.205**2
           PUH3=-1.501*DDEXP(-ON3)
           VC=PUH1+PUH2+PUH3 + VCOUL
	ENDIF
           RETURN
	ENTRY VLS(L,R)
           ON1=R**2/0.9296**2
           VLS=-114.5*DDEXP(-ON1)
	    RETURN
	ENTRY VT(L,R)
C                TENSORS: 
           ON1=R**2/1.539**2
           PUH1=12.24*DDEXP(-ON1)
           ON2=R**2/0.4039**2
           PUH2=-31.64*DDEXP(-ON2)
           ON3=R**2/3.015**2
           PUH3=0.8111*DDEXP(-ON3)
           VT=PUH1+PUH2+PUH3
	    RETURN
	ENTRY VLL(L,R)
	    VLL=0.
	    RETURN
	END
