C ****
C**** POTENTIEL DE MALFLIET ET TJON I  III (MT13)
C ****  UC = Triplet S-wave NP potential which binds deuteron 
C ****  VC = Singlet S-wave NN potential with virtual state
C ****
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      	parameter(XMU=1.55, HBARC=197.33, 
     X		LANDAR=7.394,LANDAS=2.64,LANDAT=3.216)
      	parameter( CAR=LANDAR*HBARC,CAS=LANDAS*HBARC,
     X             CAT=LANDAT*HBARC)
      		C=EXP(-XMU*R)
      		V3S1=(-CAT*C+CAR*C*C)/R
		UC=0.0
		if(L.eq.0) UC=V3S1
		RETURN
	ENTRY ULS(L,R)
		uls=0.0
		RETURN
	ENTRY ULSC(L,R)
		ULSC = 0d0
		RETURN
	ENTRY ULL(L,R)
		ULL=0.0
		RETURN
	ENTRY UT(L,R)
		UT=0.0
		RETURN
	ENTRY VC(L,R)
      		C=EXP(-XMU*R)
      		V1S0=(-CAS*C+CAR*C*C)/R
		VC=0.0
		if(L.eq.0) VC=V1S0
		RETURN
	ENTRY VLS(L,R)
		VLS=0.
		RETURN
	ENTRY VT(L,R)
		VT=0.
		RETURN
	ENTRY VLL(L,R)
		VLL=0.
		RETURN
	END
