C ****
C ****  Simple singlet NN potential with scattering length a = -20.0 fm
C ****  Simple triplet NN potential from Petrov
C ****
	FUNCTION VC(L,R)
		IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		VC=0D0
		IF(mod(L,2).EQ.0) VC=-31.D0*DDEXP(-(R/1.8D0)**2)
		IF(mod(L,2).EQ.1) VC=-71.09D0*DDEXP(-(R/1.4984D0)**2)
		RETURN
	ENTRY VLS(L,R)
		VLS=0.
		RETURN
	ENTRY VT(L,R)
		VT=0.
		RETURN
	ENTRY VLL(L,R)
		VLL=0.
		RETURN
	END
