*****BINCC**************************************************************
      SUBROUTINE BINCC(Y,M,K2,IL,CONV,ISC,LV,JV,SV,ICV,JTARG,JTOT,SL2,
     &   EMID,DE,NK,ETAP,NMAX,H,PCON,TRES,TDEL,TKMAT,TKNRM,LMX1,KIN,RIN)
      IMPLICIT REAL*8(A-H,O-Z)
	parameter(KO=6)
      REAL*8 KMIN,KMAX,K,KP,INTP,K2(M),JTOT,JTARG(M),SV,SL2(M),JV(M)
      INTEGER PCON,LV(M),ICV(M),IOP(M)
      LOGICAL SING,TRES,TKNRM,TDEL,RIN,TKMAT,VIRT
      COMPLEX*16 CH,CHD,TMAT,TMATI,T,CI,YFAC,MAT(2*M,3*M),SMAT(M,M),
     &           W(NMAX+1,M,M),KMAT(M,M),SOL(M,M+M)
      REAL*8 F(NMAX+1,M,M),ZI(M,M),ZM(M,M),ZP(M,M)
      REAL*8 ETAP(M),Y(NMAX+1,M),COUPL(M,M),C,DEG(M)
      REAL*8 ETA,KJ,CF(LMX1),CG(LMX1),CFP(1),CGP(1),KEIG(M),DEGLAST(M)
C
C     pcon    trace iterations     final iteration    list wave function
C      0          no                    no               no
C      1          no                    yes              yes
C      2          no                    yes              no
C      3          yes                   yes              yes
C      4          yes                   yes              no
C
C  If TDEL, multiply wave functions by phase of T before integrating
C  If TRES, then multiply wave functions by abs(T) before integrating.
C  If TKMAT, then multiply wave functions by 1+iK matrix before integrating.
C  If TKNRM, then multiply wave functions by k before integrating.
!	write(142,*) 'TRES,TDEL,TKMAT,TKNRM =',TRES,TDEL,TKMAT,TKNRM
C
      NMAXP=NMAX+1
	MAXNR = 2*M
	MAXNR1 = 3*M
      SMALL = 1d-100
      HP=H*H
      R12 = 1./12.
      CI = (0.,1.)
      PI = 4.0*ATAN(1d0)
      SQFPI = SQRT(4.*PI)
      RADEG = 180.0/PI
      HP12 = HP*R12
       II = MIN(NK/10,1)
      MATCH = NMAX-10
	EMAX = EMID+DE*0.5
	EMIN = EMID-DE*0.5
	KMAX = sqrt(EMAX*CONV)
	KMIN = sqrt(EMIN*CONV)
	PMUL = 1d0
      DK = (KMAX - KMIN)/(NK-1)
      INTP = DK * SQRT(2.0/PI)
      DEGLAST(:) = 0.
       VIRT = .false.
       DO 12 L=1,M
       if(LV(L).eq.0) VIRT = .true.
         DO 10 N=1,NMAXP
10       Y(N,L) = 0.0
12     CONTINUE
	IFM = 144
	if(VIRT) IFM=145
        YINT = 0.0
        IF(PCON.GE.3) then
!        write(142,*) K2(1:M)
       WRITE(KO,998)
       endif
C
      DO 90 IK=1,NK
         K = KMIN + (IK-1)*DK
         KP= K*K
         NOP = 0
         do 20 J=1,M
         TKJ = K2(IL) + KP-K2(J)
         if(TKJ>0.) then
            NOP = NOP+1
            IOP(NOP) = J
            endif
20	  continue
C
      DO 30 L=1,M
      DO 28 J=1,M
      ZI(J,L) = 0.0
28    ZM(J,L) = 0.0
C 30    ZI(L,L) = H**(LV(L)+1) / EXP(0.5 * ALGAMMA(LV(L)+2d0))
30    ZI(L,L) = H**(LV(L)+1) 
C
      F(1,:,:) = 0d0
      DO 60 I=2,NMAXP
	 R = (I-1)*H
         RRI= 1.0/(I-1.)**2
      DO 42 IT=1,M
      DO 42 J=1,M
42    F(I,J,IT) = ZI(IT,J) * (1. + LV(J)*(LV(J)+1)*RRI*R12 )
       DO 45 J=1,M
       DO 45 L=1,M
         C = -POT(R,LV(L),LV(J),JTARG(ICV(L)),JTARG(ICV(J)),
     X 		    JV(L),JV(J),SV,PMUL,SL2(L),JTOT,L,J,KIN,RIN)*CONV
         IF(L.EQ.J) C = C + K2(IL) + KP-K2(J)
       COUPL(L,J) = C
       IF(C.EQ.0) GO TO 44
       C = C * HP12
          DO 43 IT=1,M
43         F(I,L,IT) = F(I,L,IT) - C * ZI(IT,J)
44    CONTINUE
45    CONTINUE
      DO 49 IT=1,M
         DO 49 L=1,M
49       MAT(IT,L) = 0.0
      DO 54 L=1,M
      DO 54 J=1,M
      C = COUPL(L,J)
      IF(C.EQ.0.0) GO TO 54
      C = C * HP
      DO 53 IT=1,M
53    MAT(IT,L) = MAT(IT,L) + C * F(I,J,IT)
54    CONTINUE
      DO 55 J=1,M
      DO 55 IT=1,M
      ZP(IT,J) = 2*ZI(IT,J) - ZM(IT,J) - MAT(IT,J)
     &                      + F(I,J,IT) * LV(J)*(LV(J)+1) * RRI
      ZM(IT,J) = ZI(IT,J)
55    ZI(IT,J) = ZP(IT,J)
60    CONTINUE
      X = (NMAXP-1) * H
      DO 65 J=1,MAXNR1
      DO 65 L=1,MAXNR
65       MAT(L,J) = 0.0
      DO 75 J=1,M
         DO 70 IT=1,M
            MAT(J,IT) = F(NMAXP,J,IT)
70          MAT(J+M,IT)=F(NMAX ,J,IT)
         TKJ = K2(IL) + KP-K2(J)
         KJ = SQRT(ABS(TKJ))
         L= LV(J)
         XL= L
         ETA = ETAP(J) * 0.5 / KJ
         IF(TKJ.GT.0.0) THEN
            CALL COULFG(KJ*X,ETA,0D0,XL,CF,CG,CFP,CGP,2,0,I,M1)
             CH  = CMPLX(CG(L+1),CF(L+1)) * (0.,.5)
            CALL COULFG(KJ*(X-H),ETA,0D0,XL,CF,CG,CFP,CGP,2,0,I,M1)
             CHD = CMPLX(CG(L+1),CF(L+1)) * (.0,.5)
         ELSE
         IE = 0
           CALL WHIT(ETA,X,KJ,E,L,CF,CG,IE)
           CH = CF(L+1) * (0.,.5)
           CALL WHIT(ETA,X-H,KJ,E,L,CF,CG,IE)
           CHD = CF(L+1) * (0.,.5)
         ENDIF
      IF(PCON.GE.5) WRITE(142,*) J,TKJ/CONV,KJ,X,L,ETA,CH,CHD
     x       			,MAT(J,J),MAT(J+M,J)
          MAT(J,J+M) = CH
          MAT(J+M,J+M)=CHD
             MAT(J,2*M+J) = - CONJG(CH)
             MAT(J+M,2*M+J)=- CONJG(CHD)
75      CONTINUE
C
       CALL GAUSS(2*M,MAXNR,MAT,M,SING,T,SMALL,.FALSE.)
C         IF(SING) STOP 'SINGULAR BIN'
          IF(SING) THEN
             WRITE(KO,*) 'SINGULAR ENERGY SOLUTION OMITTED FROM BIN,'
             WRITE(KO,77) ((K2(IL) + KP-K2(J))/CONV,J=1,MIN(M,5))
77           FORMAT(' at channel energies =',5F10.4)
             GO TO 90
           ENDIF
C
	if(PCON>0) write(142,*) ' Smatrix at E =',real(KP/conv)
	do 79 I=1,M
	do 78 J=1,M
78	SMAT(I,J) = MAT(M+I,2*M+J)
79	if(PCON>0) write(142,791) (SMAT(I,IOP(J)),J=1,NOP)
791	format(3x,6(f12.5,f9.5))
792	format(3x,8f12.5)

      W(:,:,:) = 0.
      do 80 IO=1,NOP
       IN = IOP(IO)
      NP = 2*M + IN
      DO 80 J=1,M
      DO 80 IT=1,M
      DO 80 N=1,NMAXP
      W(N,J,IO) = W(N,J,IO) + F(N,J,IT) * MAT(IT,NP)  
80    continue    

C		Now find K matrix as (1+S) K = i(1-S):
	do 82 I=1,NOP
	do 81 J=1,NOP
	SOL(I,J) = SMAT(I,IOP(J))
81	SOL(I,NOP+J) = -SMAT(I,IOP(J))
	SOL(I,I) = SOL(I,I) + 1d0
82	SOL(I,NOP+I) = SOL(I,NOP+I) + 1d0
	do 821 I=1,NOP
	do 821 J=1,NOP
821	SOL(I,NOP+J) = (0d0,1d0) * SOL(I,NOP+J)
		
       CALL GAUSS(NOP,M,SOL,NOP,SING,T,SMALL,.false.)
	KMAT(1:NOP,1:NOP) = SOL(1:NOP,NOP+1:2*NOP)
	if(PCON>4) write(142,*) ' real Kmatrix at E =',real(KP/conv)
	do 83 I=1,NOP
83	if(PCON>4) write(142,792) (real(KMAT(I,J)),J=1,NOP)
	if(PCON>4) write(142,*) 
	if(PCON>6) write(142,*) ' imag Kmatrix '
	if(PCON>4) write(142,*) ' Max imag Kmatrix =',
     x		maxval(aimag(Kmat(1:NOP,1:NOP)))
	do 831 I=1,NOP
831	if(PCON>4) write(142,792) (Aimag(KMAT(I,J)),J=1,NOP)

	do 835 I=1,NOP
         XKI = sqrt(K2(IL) + KP-K2(I))
	do 835 J=1,NOP
         XKJ = sqrt(K2(IL) + KP-K2(J))
835	ZM(I,J) = KMAT(I,J) * sqrt(XKI/XKJ)
	if(PCON>0) then
	  write(142,*) ' Symmetrised Kmatrix'
	  do 836 I=1,NOP
836	  write(142,792) (ZM(I,J),J=1,NOP)
	endif
	call HDIAG(ZM,NOP,M,1,ZI,NR)
	do I=1,NOP
	KEIG(I) = ZM(NOP+1-I,NOP+1-I)
	enddo
	if(PCON>4) then
	 write(138,*) real(KP/conv),(ZM(I,I),I=NOP,1,-1),(0.,I=NOP+1,M)
	 write(129,*)real(KP/conv),
     x    (RADEG*atan(real(ZM(I,I))),I=NOP,1,-1),(0.,I=NOP+1,M)
	  call flush(138) 
	endif

	if(PCON>0) write(142,*) 
	if(PCON>0) call flush(142) 

      IO = IL
      IN = IOP(IO)
      NP = 2*M + IN
      TMATI = (MAT(IN+M,NP)-1.)/(0.,2.)
      DEG(:) = 0.
      if(.not.TKMAT) then  !   psi_K = psi_S * exp(-i delta) etc
           X = 0.0
           IF(abs(MAT(IN+M,NP)).gt.1e-20) then
             X = (0.,-.5) * LOG(MAT(IN+M,NP))
             DEG(1) = RADEG * X
            endif
	    IP = 1
	else
	  DEG(1:NOP) = atan(KEIG(1:NOP)) * RADEG
	  IP = NOP
	endif
	 WRITE(243,9997) K,DEG(1:IP),DEGLAST(1:IP)
      DO I=1,IP
      IF(DEG(I).LT.-0.010) then
	 DEG(I) = DEG(I) + 180.0
	if(IK>1.and.abs(DEG(I)-DEGLAST(I))>45.) then
	    write(243,*) ' Jump in ch ',I
		do J=143,IFM
		write(J,*) '&'
		enddo
	    endif
	endif
	DEGLAST(I) = DEG(I)
	enddo

      BPHASE = DEG(IL)/RADEG		! chosen channel IL we hope is correct

      IF(PCON.GE.3)  WRITE(KO,999) IK,IN,K,KP/conv,
     X   MAT(il+M,NP), DELTAI,-sqfpi*tmati / conv
      IF(PCON.GE.0)  then
	 WRITE(143,9997) K,DEG(1:IP)
         WRITE(144,9997) KP/conv,DEG(1:IP)
	 if(VIRT) WRITE(145,9997) KP/CONV,(-KEIG(I)/K,I=1,IP)
	 endif

        T = EXP(-CI*BPHASE)
      do 842 J=1,M
      do 841 N=1,NMAXP
      if(TKMAT) then  !   psi_K = psi_S * (1 - i K)
	T = cos(BPHASE)
      do 84 IO=1,NOP
      do 84 I=1,NOP
       W(N,J,IO) = W(N,J,IO) - (0d0,1d0)*W(N,J,I)*KMAT(I,IO)
84    continue
      endif
	if(mod(N,10)==0.and.PCON>2)
     x 	write(150+J,843) (N-1)*H,(W(N,J,IO)*T,IO=1,min(NOP,1))
841    continue
842	if(PCON>0) write(150+J,*) '&'
843	format(f8.3,1p,12e11.3)
    
      IO = IL
      YFAC = 1.0
      X = 1.0; R = 1.0
      if(.not.TKMAT) then  !   psi_K = psi_S * exp(-i delta) etc
        IF(TDEL) YFAC = EXP(-CI*BPHASE)
        IF(TRES) YFAC = CONJG(TMATI)
      else   !   psi_K = psi_S * (1 - i K)
        YFAC = cos(BPHASE)
        IF(TRES) YFAC = YFAC * abs(sin(BPHASE))
         XKJ = sqrt(K2(IL) + KP-K2(IL))
	do I=1,NOP
	 X = X + KMAT(I,IO)**2
         XKI = sqrt(K2(IL) + KP-K2(I))
	 R = R + KMAT(I,IO)**2 * XKI/XKJ
	 enddo
      endif
        IF(TKNRM) YFAC = YFAC*K
	if(PCON>=1) write(150,*)real(KP/conv),abs(YFAC*sqrt(X))
     x		,abs(YFAC*sqrt(R))
 	if(PCON>=5) write(139,*)real(KP/conv), 
     x     real(KMAT(1:NOP,IO)),(0.,I=NOP+1,M)
      YINT = YINT + X * ABS(YFAC)**2 * DK
C
      DO 85 N=1,NMAXP
      DO 85 J=1,M
      Y(N,J) = Y(N,J) + W(N,J,IO) * YFAC * INTP
85    continue

      IF(PCON.GE.5.AND.IK/II*II.EQ.IK) THEN
      DO 86 J=1,M
         BE = (K2(IN) + KP-K2(J))/CONV
!         if(PCON>0) write(142,*) BE,K2(IN),KP,K2(J),CONV,IN,J
         KJ = SQRT(ABS(BE)*CONV)
       if(J.eq.IN) then
         TMAT = (MAT(J+M,NP)-1.)/(0.,2.)
         DELTA = 0.0
         IF(abs(MAT(J+M,NP)).gt.1e-20)
     x   DELTA = RADEG * (0.,-.5) * LOG(MAT(J+M,NP))
         IF(DELTA.LT.0.0) DELTA = DELTA + 180.0
         C =-SQFPI * TMAT / CONV
          IF(BE.GT.0) WRITE(KO,999) IK,J,K,BE,MAT(J+M,NP),DELTA,C
          IF(BE.LE.0) WRITE(KO,9999) IK,J,K,BE,MAT(J+M,NP)
       else
          IF(BE.GT.0) WRITE(KO,999) IK,J,K,BE,MAT(J+M,NP)
          IF(BE.LE.0) WRITE(KO,9999) IK,J,K,BE,MAT(J+M,NP)
       endif
86     continue
       ENDIF
       
90    CONTINUE
      IF(PCON.ge.0) then
	write(143,*) '&'; call  flush(143)
        write(144,*) '&'; call  flush(144)
        if(VIRT) write(145,*) '&'; call  flush(145)
	if(PCON>4) write(138,*) '&'; call  flush(138)
	if(PCON>0) then
	  write(150,*) '&'; call  flush(150)
	  write(139,*) '&'; call  flush(139)
	  endif
	endif
      YINT = 1.0/SQRT(YINT)
C
      WOLD = -1.
      IF(MOD(ISC,2).EQ.1) THEN
       X = 0.0
C                        NORMALISE WAVE FUNCTION TO UNITY EXACTLY!!
       DO 92 J=1,M
       DO 92 N=2,NMAX
       X = X + Y(N,J)**2
  92   CONTINUE
C!     C = 1.0 / SQRT(X*H) * (0.,1.)**(MIN(ISC,-1)+1)
       C = 1.0 / SQRT(X*H)
       WOLD = YINT/ABS(C)
      ELSE
C                   Normalise according to YINT
C                    (if not TRES, then YINT = KMAX - KMIN)
       C = YINT
      ENDIF
       DO 95 N=1,NMAX
       DO 93 J=1,M
93     Y(N,J) = Y(N,J) * C
95     CONTINUE
C
      WNORM = 0.0
      RMS   = 0.0
      DO 102 J=1,M
	if(LV(J)>0) Y(1,J) = 0.0
      DO 100 N=2,NMAX
      X=(N-1)*H
      WNORM = WNORM + Y(N,J)**2
      RMS   = RMS   + Y(N,J)**2 * X*X
      Y(N,J) = Y(N,J)/X
100   CONTINUE
      if(LV(J)==0) Y(1,J) = 2*Y(2,J)-Y(3,J)
102   CONTINUE
      WNORM = SQRT(WNORM*H)
      RMS   = SQRT(RMS*H)/WNORM
      IF(WOLD.LT.0.) WOLD=WNORM
      IF(PCON.GT.0) WRITE(KO,991) WNORM,WOLD,RMS
      IF(PCON.EQ.0)RETURN
C
  991 FORMAT(  / '0 Norm =',F8.4,' from =',F8.4,', RMS =',F8.4)
C
      IF(MOD(PCON,2).EQ.0)      RETURN
      DO 996 J=1,M
      WRITE(146,992) J,LV(J)
  992 FORMAT('# For channel #',I3,' with L =',I2)
	do 993 n=1,nmax
  993	write(146,*) (n-1)*real(H),y(n,j)
	write(146,*) '&'
  996 CONTINUE
  997 FORMAT(4(I4,2X,E11.4,3X))
  998 FORMAT(3(I4,2X,2E11.4,3X))
 9997 FORMAT(F9.4,10f8.3)
 9998 FORMAT(F11.7,F9.4,F11.6,f9.4)
 9999 FORMAT(' For #',i4,i2,', K,BE =',2F11.7,': S =',2F12.2)
  999 FORMAT(' For #',i4,i2,', K,BE =',2F11.7,': S =',2F9.4,:,
     & ' & Del =',F8.3,',  D0 =',2F9.2)
      RETURN
      END
      SUBROUTINE GAUSS(N,NR,A,M,SING,DET,EPS,SHOW)
C
C    SOLVE BY GAUSSIAN ELIMINATION SUM(J): A(I,J).P(J) = A(I,N+1)
C             WHERE P(J) IS LEFT IN MAT(J,N+1)
C
       IMPLICIT REAL*8(A-H,O-Z)
	parameter(KO=142)
       COMPLEX*16 A(NR,N+M),DET,RA
       LOGICAL SING,SHOW
       SING  = .FALSE.
      NPM = N + M
      DO 201 I=1,N
201   IF(SHOW) WRITE(KO,402) (            A(I,J)  ,J=1,NPM)
      DET = 0.
      DO 9 K = 1, N
      IF (abs(A(K,K)) .NE. 0.0 ) GO TO 5
         SING = .TRUE.
         WRITE(KO,3) K,DET/LOG(10.)
    3  FORMAT(//' THE MATRIX IS SINGULAR AT',I3,', Log10 determinant is
     &  ',2E16.8/)
      DO 401 I=1,N
401   IF(SHOW) WRITE(KO,402) (            A(I,J)  ,J=1,NPM)
C402   FORMAT( 1X,20F6.1/(1X,20F6.3))
402   FORMAT( 1X,1P,14E9.1/(1X,24E9.1))
         RETURN
    5 KP1 = K + 1
      DET = DET + LOG(A(K,K))
         RA = 1.0/A(K,K)
      DO 6 J = KP1, NPM
    6 A(K,J) = A(K,J) * RA
      A(K,K) = 1
      DO 9 I = 1, N
      IF (I .EQ. K  .OR. ABS (A(I,K)) .EQ. 0) GO TO 9
CDIR$ IVDEP
         DO 8 J = KP1, NPM
    8    A(I,J) = A(I,J) - A(I,K)*A(K,J)
         A(I,K) = 0
    9 CONTINUE
      IF(SHOW) WRITE(KO,15 ) DET/LOG(10.)
15    FORMAT(/' Log10 determinant is ',2F10.5)
      IF(SHOW) WRITE(KO,402) (A(I,N+1),I=1,N)
      RETURN
      END
