	SUBROUTINE ENUMFADCRX(cc,J,PTY,KMX,LNNMAX,LNCMAX,SMAX,K2MAX,
     & 		K3MAX,NTARG,JTARG,PTARG, MAXL, readpw,pwfile,thresh,opw,
     &		LLMAX,MAXL2,KK3,LLTOT3,LL13,LL23,SSTOT3,JNN3,II3,  
     &  	KK2,LLTOT2,LL12,LL22,SSTOT2,JNN2,II2,MCH,JNNMX,JNNPREF,
     & 		IMAX3,IMAX2,LDMIN,LDMAX,L1MX,L2MX,nooddcn,nooddnn)
C ENUMERATES HYPERANGULAR&SPIN STATES FOR A GENERAL NNC SYSTEM
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	INTEGER PTY,S,SSTOT2,SSTOT3,SMAX,K3MAX(0:MAXL+2,NTARG),PTARG(5)
	INTEGER K2MAX(0:MAXL+1,NTARG),S1,LLL,cc
	DIMENSION KK3(MCH),LLTOT3(MCH),LL13(MCH),LL23(MCH),SSTOT3(MCH),
     &            KK2(MCH),LLTOT2(MCH),LL12(MCH),LL22(MCH),SSTOT2(MCH),
     &	      	  JNN3(MCH),II3(MCH),JNN2(MCH),II2(MCH)
      	DOUBLE PRECISION JTARG(5),J
	COMMON /ISOSPIN/ZN,ZC,ISOSP
	CHARACTER*80 pwfile
	LOGICAL readpw,nooddnn,nooddcn,opw

!	write(6,*) 'EFADNUM: JNNMX,JNNPREF:',JNNMX,JNNPREF

	KSTARTT=2
	KSTARTY=2

	KSTARTT=0
	KSTARTY=0
	if(max(KSTARTT,KSTARTY)>0.and.cc==1) write(6,*) 
     X	' Minimum K allowed for T,Y bases =',KSTARTT,KSTARTY
	LDMAX=-1
	LDMIN=+1
	L1MX=-1
	L2MX=-1
	if(readpw) go to 100
C--------------------------------------------------T / Cluster / alpha basis
	L1INC=1
	if(nooddnn) L1INC=2
	I=0
	DO 20 IC=1,NTARG
	NPTY = PTY*PTARG(IC)
c	write(6,*) ' K3MAX(+1,+2,',IC,') =',K3MAX(MAXL+1,IC),
c    x		K3MAX(MAXL+2,IC),MAXL
	IF(NPTY.EQ.1)THEN 
		NN=0
	ELSE
		NN=1
	ENDIF
	KMAX = ((KMX-NN)/2)*2 + NN
	KMIN =  NN
	KMIN =  max(NN,KSTARTT)
	JNNM = min(JNNMX,nint(abs(J+JTARG(IC))))
	DO 20 JNN=nint(abs(J-JTARG(IC))),JNNM
	  if(JNNPREF.ge.0.and.mod(JNN-JNNPREF,2).ne.0) go to 20
!	  write(6,*) 'Try Jnn =',JNN
	DO 10 K=KMIN,KMAX,2
	NMAX=K/2
	DO 10 S1=0,1
	DO 10 LLL=abs(S1-JNN),S1+JNN
	DO 10 N=0,NMAX
C N=(K-L1-L2)/2
	L1MAX=MIN0(K-2*N,LNNMAX)
	DO 10 L1=0,L1MAX,L1INC
	L2=K-L1-2*N
	LMI=IABS(L1-L2)
	LMA=min(L1+L2,LLMAX)
c	S=L1-2*(L1/2)
 	S=mod(L1+ISOSP+1,2)
!	do 10 S=0,1
	IF(S.EQ.0)THEN
	  LMIN=JNN
	  LMAX=JNN
	ELSE
	  IF(JNN.EQ.0)THEN
	    LMIN=1
	    LMAX=1
	  ELSE
	    LMIN=JNN-1
	    LMAX=JNN+1
	  ENDIF
	ENDIF
	DO 10 L=LMIN,LMAX
!	 write(6,*) ' Try K,L,L1,L2,S,JNN,IC =',K,L,L1,L2,S,JNN,IC
	IF(LMI.LE.L.and.LMA.GE.L.and.S.LE.SMAX
     x	    .and.(K.le.K3MAX(L1,IC)
     x 	              .or.(L1.eq.K/2.and.K.le.K3MAX(MAXL+2,IC)) )
     x 	    .and.(L1.lt.2.or.L2.lt.2.or.(K.le.K3MAX(MAXL+1,IC)
     x 	              .or.(L1.eq.K/2.and.K.le.K3MAX(MAXL+2,IC)) ) )
c    x 	    .and.JNN.le.0
     x      .and.L2.le.min(MAXL,MAXL2))THEN
		if(S.ne.S1) go to 10
		if(L.ne.LLL) go to 10
	   I=I+1
	if(cc==2) then
	   KK3(I)=K
	   LLTOT3(I)=L
	   LL13(I)=L1
	   LL23(I)=L2
	   SSTOT3(I)=S
	   JNN3(I)=JNN
	   II3(I)=IC
	endif
 	      LD=(L1-L2+NN)/2
	      LDMIN=min(LDMIN,LD)
	      LDMAX=max(LDMAX,LD)
	      L1MX=max(L1MX,L1)
	      L2MX=max(L2MX,L2)
	ENDIF
10	CONTINUE
20	CONTINUE
	IMAX3=I

C--------------------------------------------------Y / Shell / beta basis
	L1INC=1
	if(nooddcn) L1INC=2
	I=0
	DO 60 IC=1,NTARG
	NPTY = PTY*PTARG(IC)
	IF(NPTY.EQ.1)THEN 
		NN=0
	ELSE
		NN=1
	ENDIF
	KMAX = 0
	   DO L1=0,LNCMAX,L1INC
	   KMAX = max(KMAX,((K2MAX(L1,IC)-NN)/2)*2 + NN)
	   enddo
	KMIN =  NN
	KMIN =  max(NN,KSTARTY)
c		write(6,*) 'Y basis: look for K=',KMIN,KMAX
	JNNM = min(JNNMX,nint(abs(J+JTARG(IC))))
	DO 60 JNN=nint(abs(J-JTARG(IC))),JNNM
	  if(JNNPREF.ge.0.and.mod(JNN-JNNPREF,2).ne.0) go to 60
	DO 50 K=KMIN,KMAX,2
	NMAX=K/2
	DO 50 N=0,NMAX
C N=(K-L1-L2)/2
	L1MAX=MIN0(K-2*N,LNCMAX)
	DO 50 L1=0,L1MAX,L1INC
	L2=K-L1-2*N
	LMI=IABS(L1-L2)
	LMA=L1+L2
	LMA=min(L1+L2,LLMAX)
	DO 50 S=0,1
	IF(S.EQ.0)THEN
	   LMIN=JNN
	   LMAX=JNN
	ELSE
	   IF(JNN.EQ.0)THEN
	      LMIN=1
	      LMAX=1
	   ELSE
	      LMIN=JNN-1
	      LMAX=JNN+1
	   ENDIF
	ENDIF
	DO 50 L=LMIN,LMAX
 	IF(LMI.LE.L.AND.LMA.GE.L.and.S.le.SMAX.and.L2.le.min(MAXL,MAXL2)
     x 	    .and.(L1.lt.2.or.L2.lt.2.or.K.le.K2MAX(MAXL+1,IC))
c    x 	    .and.JNN.le.0
     x	    .and.K.le.K2MAX(L1,IC)) THEN
	   I=I+1
	if(cc==2) then
	   KK2(I)=K
	   LLTOT2(I)=L
	   LL12(I)=L1
	   LL22(I)=L2
	   SSTOT2(I)=S
	   JNN2(I)=JNN
	   II2(I)=IC
	endif
 	      LD=(L1-L2+NN)/2
	      LDMIN=min(LDMIN,LD)
	      LDMAX=max(LDMAX,LD)
	      L1MX=max(L1MX,L1)
	      L2MX=max(L2MX,L2)
	ENDIF
50	CONTINUE
60	CONTINUE
	IMAX2=I
	RETURN
100	if(.not.opw) then
	write(90,*) 'Open file ',pwfile
	open(89,file =pwfile,access = 'sequential',
     x         form='formatted',status = 'old')
	opw = .true.
	endif
	read(89,*) i2,i3
	write(90,*) i2,i3, ' at cc =',cc
	if(cc.eq.1) then
	  close(9)
	  return
	endif
	i = 1
	KMAX =-1
	do 110 iii=1,i2
	read(89,*) in,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),chnm
	write(90,*) in,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),chnm
	if(chnm.gt.thresh.and.(.not.nooddcn.or.mod(LL12(I),2).eq.0))then
		KMAX = max(KMAX,KK2(I))
		NPTY = PTY*PTARG(II2(i))
		IF(NPTY.EQ.1)THEN 
			NN=0
		ELSE
			NN=1
		ENDIF
 	        LD=(LL12(I)-LL22(I)+NN)/2
	        LDMIN=min(LDMIN,LD)
	        LDMAX=max(LDMAX,LD)
	        L1MX=max(L1MX,LL12(I))
	        L2MX=max(L2MX,LL22(I))
		i=i+1
	    endif
110	continue
	IMAX2 = i-1
	i = 1
	do 120 iii=1,i3
	read(89,*) in,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(i),chnm
	write(90,*) in,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(i),chnm
	if(chnm.gt.thresh.and.(.not.nooddnn.or.mod(LL13(I),2).eq.0))then
		KMAX = max(KMAX,KK3(I))
		NPTY = PTY*PTARG(II3(i))
		IF(NPTY.EQ.1)THEN 
			NN=0
		ELSE
			NN=1
		ENDIF
 	        LD=(LL13(I)-LL23(I)+NN)/2
	        LDMIN=min(LDMIN,LD)
	        LDMAX=max(LDMAX,LD)
	        L1MX=max(L1MX,LL13(I))
	        L2MX=max(L2MX,LL23(I))
		i=i+1
	    endif
120	continue
	IMAX3 = i-1
	write(6,*) ' Partial waves determined from file, KMAX =',KMAX,
     & 	 ' LDMIN,LDMAX,L1MX,L2MX =',LDMIN,LDMAX,L1MX,L2MX
	KMX = KMAX
	return
	END
