	FUNCTION FANNLS(L1,L2,LNN,LNN1,JNN)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
	FANNLS=0d0
C				Call ONLY if SNN=SNN1=1
	if(.not.ACTIVE(LNNLS)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	if(L1.eq.0) return
	if(LNN+LNN1.lt.1.or.abs(LNN-LNN1).gt.1) return
	N=JNN+L1+L2
	N=N-2*(N/2)
	AL1=L1
	AL2=L2
	ALNN=LNN
	ALNN1=LNN1
	AJNN=JNN 
	FANNLS=SQ6*(-1)**N
     &        *DSQRT(L1*(L1+1.D0)*(2*L1+1)*(2*LNN+1)*(2*LNN1+1))*
     &         SIM6J(AL1,AL2,ALNN,ALNN1,1.D0,AL1)*
     &         SIM6J(ALNN1,ALNN,1.D0,1.D0,1.D0,AJNN)  
	FANNLS=FANNLS * (-1)**(LNN+LNN1)
	RETURN
	END

	FUNCTION FANNT(L1,L11,L2,LNN,LNN1,JNN,KL)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
	FANNT = 0.0
C				Call ONLY if SNN=SNN1=1
	if(KL.eq.1.and..not.ACTIVE(LNNT)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	IF(L1+L11.lt.2.or.abs(L1-L11).gt.2) return
!	IF(L1/=L11) return  !!!TEST ONLY
!	IF(LNN/=LNN1) return  !!!TEST ONLY
	IF(LNN+LNN1.lt.2.or.abs(LNN-LNN1).gt.2) return
	N=JNN+L2+1
	N=N-2*(N/2)
	AL1=L1
	AL11=L11
	AL2=L2
	ALNN=LNN
	ALNN1=LNN1
	AJNN=JNN
	FANNT=(-1)**N*2.*SQ5*SQ6*DSQRT((2.D0*L1+1)*(2*L11+1)
     &     *(2*LNN+1)*(2*LNN1+1))
     &     *SIM6J(ALNN1,ALNN,2.D0,1.D0,1.D0,AJNN)
     &     *SIM6J(AL1,AL2,ALNN,ALNN1,2.D0,AL11)
     &     *WIG(2*L1,2*L11,4,0,0)
	FANNT=FANNT * (-1)**(LNN+LNN1)
	RETURN
	END

	FUNCTION FANNLL(L1,L2,LNN,LNN1,JNN,KL)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
C				Call ONLY if SNN=SNN1=1
	FANNLL=0.
	if(KL.eq.1.and..not.ACTIVE(LNNLL)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	IF(L1.EQ.0) RETURN
	IF(LNN+LNN1.lt.2.or.abs(LNN-LNN1).gt.2) return
	N=JNN+L1+L2+1	
	N=N-2*(N/2)
	AL1=L1
	AL2=L2
	ALNN=LNN
	ALNN1=LNN1
	AJNN=JNN 
	FANNLL=(-1)**N*2.D0*SQ5/SQ6 * 
     &         SIM6J(ALNN1,ALNN,2D0,1D0,1D0,AJNN)*
     &         SIM6J(AL1,AL2,ALNN,ALNN1,2.D0,AL1)*
     &    DSQRT((2.D0*L1-1)*L1*(L1+1)*
     &          (2*L1+1)*(2*L1+3)*(2*LNN+1)*(2*LNN1+1))
	FANNLL=FANNLL * (-1)**(LNN+LNN1) * 3.0
	RETURN
	END	

	FUNCTION FANCLS(L1,L2,LNN,LNN1,SNN,SNN1,JNN)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
	INTEGER SNN,SNN1
	DIMENSION F(0:1,0:1)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
	FANCLS = 0d0
 	if(.not.ACTIVE(LNCLS)) return
 	if(LVACT.ge.0.and.L1.ne.LVACT) return
	IF(L1.EQ.0) RETURN
	if(LNN+LNN1.lt.1.or.abs(LNN-LNN1).gt.1) return
	if(SNN+SNN1.lt.1) return
	N=JNN+L1+L2+1
	N=N-2*(N/2)
	AL1=L1
	AL2=L2
	ALNN=LNN
	ALNN1=LNN1
	AJNN=JNN
	ASNN=SNN
	ASNN1=SNN1
	F(0,0)=0.0
	F(0,1)=-.5*SQ3
	F(1,0)=-.5*SQ3
	F(1,1)=-.5*SQ6
	FANCLS=(-1)**N*DSQRT(L1*(L1+1D0)*(2*L1+1)*(2*LNN+1)*(2*LNN1+1))*
     &         SIM6J(AL1,AL2,ALNN,ALNN1,1.D0,AL1)*
     &         SIM6J(ALNN1,ALNN,1.D0,ASNN,ASNN1,AJNN)*F(SNN,SNN1)  
        FANCLS=FANCLS * (-1)**(LNN+LNN1+SNN+SNN1)
	RETURN
	END

	FUNCTION FANCLSC(L1,L2,LNN,LNN1,SNN,JNN,JNN1,AJTARG,JT)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
C					Call ONLY if SNN=SNN1 
C		note that SNN*,JNN* are real here (easy for occ.f)
	DOUBLEPRECISION JT,SNN,JNN,JNN1
	parameter (Z=0d0)
	include 'actives.f'
	FANCLSC = 0d0
	if(.not.ACTIVE(LNCLSC)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	if(AJTARG.lt.0.5) return
	FANCLSC = (-1)**NINT(JT+AJTARG-SNN+LNN+LNN1+L1+L2)
     & 		* sqrt((2*JNN+1)*(2*JNN1+1)*(2*LNN+1)*(2*LNN1+1) 
     &		      * L1*(L1+1)*(2*L1+1)
     &		      * AJTARG*(AJTARG+1)*(2*AJTARG+1))
     &		* SIM6J(JNN+Z,JNN1+Z,1d0,AJTARG,AJTARG,JT)
     &		* SIM6J(LNN+Z,SNN+Z,JNN+Z,JNN1+Z,1d0,LNN1+Z)
     &		* SIM6J(L1+Z,L2+Z,LNN+Z,LNN1+Z,1d0,L1+Z)
        FANCLSC=FANCLSC * (-1)**nint(LNN+LNN1+SNN+SNN-JNN-JNN1)
	RETURN
	END

	FUNCTION FANCLL(L1,L2,LNN,LNN1,SNN,SNN1,JNN,JNN1,AJTARG,JT)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
C		note that SNN*,JNN* are real here (easy for occ.f)
	DOUBLEPRECISION JT,SNN,SNN1,JNN,JNN1
	parameter(Z=0d0, ONE=1d0)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
	FANCLL=Z
	if(.not.ACTIVE(LNCLL)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	IF(L1.EQ.0) RETURN
	IF(LNN+LNN1.lt.2.or.abs(LNN-LNN1).gt.2) return
	S1 = SN
	S2 = SN
	if(abs(JT-nint(JT)).lt.0.1) S2=Z
	if(AJTARG+S1.lt.ONE) return
C					FANNLL nonzero only if S13=S13'=1
C					call FANNLL only if J13=J13'
	S13=ONE
	S13P=ONE
	DO 100 J13=abs(JT-SN),JT+SN
	J13P = J13
	if(J13.lt.abs(LNN-S13).or.J13.gt.LNN+S13) go to 100	
	if(J13P.lt.abs(LNN1-S13P).or.J13P.gt.LNN1+S13P) go to 100
	C1 = sqrt((2.*JNN+ONE)*(2.*J13+ONE)*(2.*SNN+ONE)*(2.*S13+ONE))
     x		* sim9j(LNN+Z, SNN, JNN, 
     X			S13,   S1,  AJTARG,
     X			J13+Z, S2,  JT)
     X		* (-1)**nint(J13-JNN+SNN-S13)
     X		* (-1)**nint(SNN+JNN-S13-J13)
	C1P=sqrt((2*JNN1+ONE)*(2*J13P+ONE)*(2*SNN1+ONE)*(2*S13P+ONE))
     x		* sim9j(LNN1+Z, SNN1, JNN1, 
     X			S13P,   S1,   AJTARG,
     X			J13P+Z, S2,   JT)
     X		* (-1)**nint(J13P-JNN1+SNN1-S13P)
     X		* (-1)**nint(SNN1+JNN1-S13P-J13P)
	FANCLL = FANCLL + C1 * C1P * FANNLL(L1,L2,LNN,LNN1,J13,2)
     x		* (-1)**(LNN+LNN1)
 100	continue	
	RETURN
	END

	FUNCTION FANCT(L1,L11,L2,LNN,LNN1,SNN,SNN1,JNN,JNN1,AJTARG,JT)
	IMPLICIT DOUBLEPRECISION(A-H,O-Z)
C		note that SNN*,JNN* are real here (easy for occ.f)
	DOUBLEPRECISION JT,SNN,SNN1,JNN,JNN1
	parameter(Z=0d0, ONE=1d0)
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	include 'actives.f'
	FANCT = Z
	if(.not.ACTIVE(LNCT)) return
	if(LVACT.ge.0.and.L1.ne.LVACT) return
	IF(L1+L11.lt.2.or.abs(L1-L11).gt.2) return
!	IF(L1/=L11) return  !!!TEST ONLY
!	IF(LNN/=LNN1) return  !!!TEST ONLY
	IF(LNN+LNN1.lt.2.or.abs(LNN-LNN1).gt.2) return
	S1 = SN
	S2 = SN
	if(abs(JT-nint(JT)).lt.0.1) S2=Z
	if(AJTARG+S1.lt.ONE) return
C					FANNT nonzero only if S13=S13'=1
C					call FANNT only if J13=J13'
	S13=ONE
	S13P=ONE
	DO 100 J13=abs(JT-SN),JT+SN
	J13P = J13
	if(J13.lt.abs(LNN-S13).or.J13.gt.LNN+S13) go to 100	
	if(J13P.lt.abs(LNN1-S13P).or.J13P.gt.LNN1+S13P) go to 100
	C1 = sqrt((2.*JNN+ONE)*(2.*J13+ONE)*(2.*SNN+ONE)*(2.*S13+ONE))
     x		* sim9j(LNN+Z, SNN, JNN, 
     X			S13,   S1,  AJTARG,
     X			J13+Z, S2,  JT)
     X		* (-1)**nint(J13-JNN+SNN-S13)
     X		* (-1)**nint(SNN+JNN-S13-J13)
	C1P=sqrt((2*JNN1+ONE)*(2*J13P+ONE)*(2*SNN1+ONE)*(2*S13P+ONE))
     x		* sim9j(LNN1+Z, SNN1, JNN1, 
     X			S13P,   S1,   AJTARG,
     X			J13P+Z, S2,   JT)
     X		* (-1)**nint(J13P-JNN1+SNN1-S13P)
     X		* (-1)**nint(SNN1+JNN1-S13P-J13P)
	F = FANNT(L1,L11,L2,LNN,LNN1,J13,2)
		F = F * (-1)**(LNN+LNN1)
	FANCT = FANCT + C1 * C1P * F
c	write(51,*) ' For',L1,L11,L2,LNN,LNN1,
c     x		real(JNN),real(JNN1),real(AJTARG),real(JT),
c     x   ' and J13 =',J13,', FANCT = * + ',real(c1),real(c1p),real(F)
 100	continue	
	RETURN
	END
c
c-----     FANCDEF calculates the matrix elements for a 3 body problem
c-----                 with core excitation: 
c-----     <lx2.ly2-Ln2,sx2.sy2-Sn2,Jn2,I2,JT | C(KKK(lx)).
c-----                C(KKK(I)) | lx1.ly1-Ln1,sx1.sy1-Sn1,Jn1,I1,JT>
c		New recoupling phase has been introduced
c		so that L*S -> S*L
c		New sqrt(2 KKK + 1) factor to use multipoles
c		produced by Deform.f
c ------------------------------------------------------
c
        Function FANCDEF(lx1,ly1,Ln1,Sn1,Jn1,I1,JT,
     &  		 lx2,ly2,Ln2,Sn2,Jn2,I2,KKK)
        implicit real*8(a-h,o-z)
	parameter(Z=0d0)
	integer lx1,lx2,ly1,ly2,Ln1,Ln2,Jn1,Jn2,Sn1,Sn2
	real*8 I1,I2,JT,J1,J2
	real*8 MEcore, MEneutron,KTARG
	COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5)
	include 'actives.f'
	FANCDEF = Z
	if(.not.ACTIVE(LNCDEF)) return
	if(LVACT.ge.0.and.lx1.ne.LVACT) return
	if(Sn1.ne.Sn2 .or. ly1.ne.ly2) return
	if(abs(I1-I2)  .gt.KKK .or. I1+I2 .lt.KKK) return
	if(abs(lx1-lx2).gt.KKK .or.lx1+lx2.lt.KKK) return
	if(abs(Ln1-Ln2).gt.KKK .or.Ln1+Ln2.lt.KKK) return
	if(abs(Jn1-Jn2).gt.KKK .or.Jn1+Jn2.lt.KKK) return

c
c   ------------------------------------------ Matix element of the core
c Here the core is assumed to be in a K=KTARG pure rotational band.
	MEcore=sqrt((2*I1+1)*(2*I2+1))*
     &         WIG(nint(2*I1),nint(2*I2),2*KKK,
     & 		   nint(2*KTARG),-nint(2*KTARG))

c   ------------------------------------------ Matrix element for the neutron
	MEneutron=(-1)**nint(JT+KTARG-Sn1+Ln1+Ln2+ly1)*
     &  sqrt((2d0*Jn1+1)*(2*Jn2+1)*(2*Ln1+1)*(2*Ln2+1)*
     &     (2*lx1+1)*(2*lx2+1))*
     &  SIM6J(Jn2+Z,Jn1+Z,KKK+Z,I1,I2,JT)*
     &  SIM6J(Jn2+Z,Jn1+Z,KKK+Z,Ln1+Z,Ln2+Z,Sn1+Z)*
     &  SIM6J(Ln2+Z,Ln1+Z,KKK+Z,lx1+Z,lx2+Z,ly1+Z)*
     &  WIG(2*lx1,2*lx2,2*KKK,0,0)

c   ------------------------------------------ Total Matrix element
	FANCDEF=MEcore*MEneutron
	FANCDEF=FANCDEF*(-1)**(Jn1+Jn2-Ln1-Ln2-Sn1-Sn2) 
     &		       *sqrt(2.*KKK+1.)
	return

c-----     FANCDEF2 calculates the matrix elements for a 2 body problem
c-----                 with core excitation: 
c-----     <s,lx2-Jn2,I2,JT | C(KKK(lx)).C(KKK(I)) | s,lx1-Jn1,I1,JT>
C-----		 with (sqrt(2*KKK+1)) factor.

	Entry FANCDEF2(lx1,lx2,I1,I2,J1,J2,S,JT,KKK)
	FANCDEF2 = Z
	if(abs(I1-I2)  .gt.KKK .or. I1+I2 .lt.KKK) return
	if(abs(lx1-lx2).gt.KKK .or.lx1+lx2.lt.KKK) return
	if(abs(J1-J2)  .gt.KKK .or. J1+J2 .lt.KKK) return

        FANCDEF2=(-1)**nint(s+2*j2+KKK+JT+KTARG)
     &              *Sqrt((2*j1+1)*(2*j2+1)*(2*lx1+1)*(2*lx2+1)
     &              *(2*I1+1)*(2*I2+1)*(2*KKK+1))
     &              *SIM6J(j1,j2,KKK+Z,I2,I1,JT)
     &              *SIM6J(j1,j2,KKK+Z,lx2+Z,lx1+Z,s)
     &              *WIG(2*lx2,2*lx1,2*KKK,0,0)
     &              *WIG(nint(2*I2),nint(2*I1),2*KKK,
     +                     nint(2*KTARG),-nint(2*KTARG))
     &              *(-1)**nint(J1+J2-Lx1-Lx2-s-s)
	return
	end

