	SUBROUTINE FACTORIAL(DLFAC,DL2FAC,N)
C N>0
C LN(I!) AND LN((2I+1)!)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION DLFAC(0:N),DL2FAC(0:N)
	DLFAC(0)=0.
	DO 1 I=1,N 
	A=I
1	DLFAC(I)=DLFAC(I-1)+DLOG(A)
	DL2FAC(0)=0.D0
	DO 2 I=1,N
	A=2.D0*I+1.D0
2	DL2FAC(I)=DL2FAC(I-1)+DLOG(A)
	CONTINUE
	RETURN
	END

	DOUBLE PRECISION FUNCTION LAGNORM(N,AL)	
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C NORM. COEFF. FOR LAGUERRE POLYNOMIALS
	dimension dlfac(0:200),dl2fac(0:200)
	COMMON/FACT/DLFAC,DL2FAC
	LAL=AL
	LAGNORM=DSQRT(DEXP(DLFAC(N)-DLFAC(N+LAL)))
	RETURN
	END

	DOUBLE PRECISION FUNCTION JACNORM(N,L1,L2)		
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C NORM. COEFFICIENT FOR JACOBI POLYNOMIALS WITH AL=L1+1/2,   
C BE=L2+1/2.
	dimension dlfac(0:200),dl2fac(0:200)
	COMMON/FACT/DLFAC,DL2FAC
	PI=3.1415926535897932384626433832795
	A=DLFAC(N)
	A1=DLFAC(N+L1+L2+1)
	A2=DL2FAC(N+L1)
	A3=DL2FAC(N+L2)
	ddd=DSQRT(2**(2*N)*(L1+L2+2.d0*N+2.d0)*DEXP(A+A1-A2-A3)/PI)
	JACNORM=SQRT(2d0**(2*N)*(L1+L2+2*N+2)*EXP(A+A1-A2-A3)/PI)
	RETURN
	END
      FUNCTION DDEXP(X)
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      IF(ABS(X).GT.80.D0) X = SIGN(80.D0,X)
      DDEXP=EXP(X)
      RETURN
      END
