      SUBROUTINE ROOTLAG(XS,X,EPS,N,AL)
C SOLUTION OF EQ. F(X)=0 BY THE NEWTON METHOD. EPS SHOWS THE ACCURACY
C OF THE SOLUTION (SEE THE PROGRAM). THE PROGRAM CALLS THE SUBR. FUN WHICH
C CALCULATES F(Y) AND ITS DERIVATIVE F1(Y). XS IS THE STARTING VALUE.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      Y=XS
 1    CONTINUE
      CALL FUN(F,F1,Y,AL,N)
      X=Y-F/F1
C      PRINT 2, X
 2    FORMAT(D24.14)
      A=DABS(X-Y)
      IF(A.LT.EPS) GO TO 3
      Y=X
      GO TO 1
 3    CONTINUE
      RETURN
      END	
	
	SUBROUTINE FUN(F,F1,Y,AL,N)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	F=POLAG(N,AL,Y)
	F1=-POLAG(N-1,AL+1.d0,Y)
	RETURN
	END
	
	
